/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of Imager.xs. Do not edit this file, edit Imager.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Imager.xs"
#define PERL_NO_GET_CONTEXT
#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_newRV_noinc
#define NEED_sv_2pv_nolen
#define NEED_sv_2pvbyte
#include "ppport.h"
#ifdef __cplusplus
}
#endif

#define i_int_hlines_testing() 1

#include "imager.h"
#include "feat.h"
#include "dynaload.h"
#include "regmach.h"
#include "imextdef.h"
#include "imextpltypes.h"
#include <float.h>

#if i_int_hlines_testing()
#include "imageri.h"
#endif

#include "imperl.h"

/* used to represent channel lists parameters */
typedef struct i_channel_list_tag {
  int *channels;
  int count;
} i_channel_list;

typedef struct {
  size_t count;
  const i_sample_t *samples;
} i_sample_list;

typedef struct {
  size_t count;
  const i_fsample_t *samples;
} i_fsample_list;

/*

Allocate memory that will be discarded when mortals are discarded.

*/

static void *
malloc_temp(pTHX_ size_t size) {
  SV *sv = sv_2mortal(newSV(size));

  return SvPVX(sv);
}

/* These functions are all shared - then comes platform dependant code */
static int getstr(void *hv_t,char *key,char **store) {
  dTHX;
  SV** svpp;
  HV* hv=(HV*)hv_t;

  mm_log((1,"getstr(hv_t %p, key %s, store %p)\n",hv_t,key,store));

  if ( !hv_exists(hv,key,strlen(key)) ) return 0;

  svpp=hv_fetch(hv, key, strlen(key), 0);
  *store=SvPV(*svpp, PL_na );

  return 1;
}

static int getint(void *hv_t,char *key,int *store) {
  dTHX;
  SV** svpp;
  HV* hv=(HV*)hv_t;  

  mm_log((1,"getint(hv_t %p, key %s, store %p)\n",hv_t,key,store));

  if ( !hv_exists(hv,key,strlen(key)) ) return 0;

  svpp=hv_fetch(hv, key, strlen(key), 0);
  *store=(int)SvIV(*svpp);
  return 1;
}

static int getdouble(void *hv_t,char* key,double *store) {
  dTHX;
  SV** svpp;
  HV* hv=(HV*)hv_t;

  mm_log((1,"getdouble(hv_t %p, key %s, store %p)\n",hv_t,key,store));

  if ( !hv_exists(hv,key,strlen(key)) ) return 0;
  svpp=hv_fetch(hv, key, strlen(key), 0);
  *store=(double)SvNV(*svpp);
  return 1;
}

static int getvoid(void *hv_t,char* key,void **store) {
  dTHX;
  SV** svpp;
  HV* hv=(HV*)hv_t;

  mm_log((1,"getvoid(hv_t %p, key %s, store %p)\n",hv_t,key,store));

  if ( !hv_exists(hv,key,strlen(key)) ) return 0;

  svpp=hv_fetch(hv, key, strlen(key), 0);
  *store = INT2PTR(void*, SvIV(*svpp));

  return 1;
}

static int getobj(void *hv_t,char *key,char *type,void **store) {
  dTHX;
  SV** svpp;
  HV* hv=(HV*)hv_t;

  mm_log((1,"getobj(hv_t %p, key %s,type %s, store %p)\n",hv_t,key,type,store));

  if ( !hv_exists(hv,key,strlen(key)) ) return 0;

  svpp=hv_fetch(hv, key, strlen(key), 0);

  if (sv_derived_from(*svpp,type)) {
    IV tmp = SvIV((SV*)SvRV(*svpp));
    *store = INT2PTR(void*, tmp);
  } else {
    mm_log((1,"getobj: key exists in hash but is not of correct type"));
    return 0;
  }

  return 1;
}

UTIL_table_t i_UTIL_table={getstr,getint,getdouble,getvoid,getobj};

void my_SvREFCNT_dec(void *p) {
  dTHX;
  SvREFCNT_dec((SV*)p);
}


static void
i_log_entry(char *string, int level) {
  mm_log((level, "%s", string));
}

static SV *
make_i_color_sv(pTHX_ const i_color *c) {
  SV *sv;
  i_color *col = mymalloc(sizeof(i_color));
  *col = *c;
  sv = sv_newmortal();
  sv_setref_pv(sv, "Imager::Color", (void *)col);

  return sv;
}

#define CBDATA_BUFSIZE 8192

struct cbdata {
  /* the SVs we use to call back to Perl */
  SV *writecb;
  SV *readcb;
  SV *seekcb;
  SV *closecb;
};

static ssize_t
call_reader(struct cbdata *cbd, void *buf, size_t size, 
            size_t maxread) {
  dTHX;
  int count;
  int result;
  SV *data;
  dSP;

  if (!SvOK(cbd->readcb)) {
    mm_log((1, "read callback called but no readcb supplied\n"));
    i_push_error(0, "read callback called but no readcb supplied");
    return -1;
  }

  ENTER;
  SAVETMPS;
  EXTEND(SP, 2);
  PUSHMARK(SP);
  PUSHs(sv_2mortal(newSViv(size)));
  PUSHs(sv_2mortal(newSViv(maxread)));
  PUTBACK;

  count = perl_call_sv(cbd->readcb, G_SCALAR);

  SPAGAIN;

  if (count != 1)
    croak("Result of perl_call_sv(..., G_SCALAR) != 1");

  data = POPs;

  if (SvOK(data)) {
    STRLEN len;
    char *ptr = SvPVbyte(data, len);
    if (len > maxread)
      croak("Too much data returned in reader callback (wanted %d, got %d, expected %d)",
      (int)size, (int)len, (int)maxread);
    
    memcpy(buf, ptr, len);
    result = len;
  }
  else {
    result = -1;
  }

  PUTBACK;
  FREETMPS;
  LEAVE;

  return result;
}

static off_t
io_seeker(void *p, off_t offset, int whence) {
  dTHX;
  struct cbdata *cbd = p;
  int count;
  off_t result;
  dSP;

  if (!SvOK(cbd->seekcb)) {
    mm_log((1, "seek callback called but no seekcb supplied\n"));
    i_push_error(0, "seek callback called but no seekcb supplied");
    return -1;
  }

  ENTER;
  SAVETMPS;
  EXTEND(SP, 2);
  PUSHMARK(SP);
  PUSHs(sv_2mortal(newSViv(offset)));
  PUSHs(sv_2mortal(newSViv(whence)));
  PUTBACK;

  count = perl_call_sv(cbd->seekcb, G_SCALAR);

  SPAGAIN;

  if (count != 1)
    croak("Result of perl_call_sv(..., G_SCALAR) != 1");

  result = POPi;

  PUTBACK;
  FREETMPS;
  LEAVE;

  return result;
}

static ssize_t
io_writer(void *p, void const *data, size_t size) {
  dTHX;
  struct cbdata *cbd = p;
  I32 count;
  SV *sv;
  dSP;
  bool success;

  if (!SvOK(cbd->writecb)) {
    mm_log((1, "write callback called but no writecb supplied\n"));
    i_push_error(0, "write callback called but no writecb supplied");
    return -1;
  }

  ENTER;
  SAVETMPS;
  EXTEND(SP, 1);
  PUSHMARK(SP);
  PUSHs(sv_2mortal(newSVpv((char *)data, size)));
  PUTBACK;

  count = perl_call_sv(cbd->writecb, G_SCALAR);

  SPAGAIN;
  if (count != 1)
    croak("Result of perl_call_sv(..., G_SCALAR) != 1");

  sv = POPs;
  success = SvTRUE(sv);


  PUTBACK;
  FREETMPS;
  LEAVE;

  return success ? size : -1;
}

static ssize_t 
io_reader(void *p, void *data, size_t size) {
  struct cbdata *cbd = p;

  return call_reader(cbd, data, size, size);
}

static int io_closer(void *p) {
  dTHX;
  struct cbdata *cbd = p;
  int success = 1;

  if (SvOK(cbd->closecb)) {
    dSP;
    I32 count;
    SV *sv;

    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    PUTBACK;

    count = perl_call_sv(cbd->closecb, G_SCALAR);

    SPAGAIN;
    
    sv = POPs;
    success = SvTRUE(sv);

    PUTBACK;
    FREETMPS;
    LEAVE;
  }

  return success ? 0 : -1;
}

static void io_destroyer(void *p) {
  dTHX;
  struct cbdata *cbd = p;

  SvREFCNT_dec(cbd->writecb);
  SvREFCNT_dec(cbd->readcb);
  SvREFCNT_dec(cbd->seekcb);
  SvREFCNT_dec(cbd->closecb);
  myfree(cbd);
}

static i_io_glue_t *
do_io_new_buffer(pTHX_ SV *data_sv) {
  const char *data;
  STRLEN length;

  data = SvPVbyte(data_sv, length);
  SvREFCNT_inc(data_sv);
  return io_new_buffer(data, length, my_SvREFCNT_dec, data_sv);
}

static const char *
describe_sv(SV *sv) {
  if (SvOK(sv)) {
    if (SvROK(sv)) {
      svtype type = SvTYPE(SvRV(sv));
      switch (type) {
      case SVt_PVCV: return "CV";
      case SVt_PVGV: return "GV";
      case SVt_PVLV: return "LV";
      default: return "some reference";
      }
    }
    else {
      return "non-reference scalar";
    }
  }
  else {
    return "undef";
  }
}

static i_io_glue_t *
do_io_new_cb(pTHX_ SV *writecb, SV *readcb, SV *seekcb, SV *closecb) {
  struct cbdata *cbd;

  cbd = mymalloc(sizeof(struct cbdata));
  cbd->writecb = newSVsv(writecb);
  cbd->readcb = newSVsv(readcb);
  cbd->seekcb = newSVsv(seekcb);
  cbd->closecb = newSVsv(closecb);

  mm_log((1, "do_io_new_cb(writecb %p (%s), readcb %p (%s), seekcb %p (%s), closecb %p (%s))\n", writecb, describe_sv(writecb), readcb, describe_sv(readcb), seekcb, describe_sv(seekcb), closecb, describe_sv(closecb)));

  return io_new_cb(cbd, io_reader, io_writer, io_seeker, io_closer, 
		   io_destroyer);
}

struct value_name {
  char *name;
  int value;
};
static int lookup_name(struct value_name *names, int count, char *name, int def_value)
{
  int i;
  for (i = 0; i < count; ++i)
    if (strEQ(names[i].name, name))
      return names[i].value;

  return def_value;
}
static struct value_name transp_names[] =
{
  { "none", tr_none },
  { "threshold", tr_threshold },
  { "errdiff", tr_errdiff },
  { "ordered", tr_ordered, },
};

static struct value_name make_color_names[] =
{
  { "none", mc_none, },
  { "webmap", mc_web_map, },
  { "addi", mc_addi, },
  { "mediancut", mc_median_cut, },
  { "mono", mc_mono, },
  { "monochrome", mc_mono, },
  { "gray", mc_gray, },
  { "gray4", mc_gray4, },
  { "gray16", mc_gray16, },
};

static struct value_name translate_names[] =
{
  { "giflib", pt_giflib, },
  { "closest", pt_closest, },
  { "perturb", pt_perturb, },
  { "errdiff", pt_errdiff, },
};

static struct value_name errdiff_names[] =
{
  { "floyd", ed_floyd, },
  { "jarvis", ed_jarvis, },
  { "stucki", ed_stucki, },
  { "custom", ed_custom, },
};

static struct value_name orddith_names[] =
{
  { "random", od_random, },
  { "dot8", od_dot8, },
  { "dot4", od_dot4, },
  { "hline", od_hline, },
  { "vline", od_vline, },
  { "/line", od_slashline, },
  { "slashline", od_slashline, },
  { "\\line", od_backline, },
  { "backline", od_backline, },
  { "tiny", od_tiny, },
  { "custom", od_custom, },
};

/* look through the hash for quantization options */
static void
ip_handle_quant_opts(pTHX_ i_quantize *quant, HV *hv)
{
  /*** POSSIBLY BROKEN: do I need to unref the SV from hv_fetch ***/
  SV **sv;
  int i;
  STRLEN len;
  char *str;

  quant->mc_colors = mymalloc(quant->mc_size * sizeof(i_color));

  sv = hv_fetch(hv, "transp", 6, 0);
  if (sv && *sv && (str = SvPV(*sv, len))) {
    quant->transp = 
      lookup_name(transp_names, sizeof(transp_names)/sizeof(*transp_names), 
		  str, tr_none);
    if (quant->transp != tr_none) {
      quant->tr_threshold = 127;
      sv = hv_fetch(hv, "tr_threshold", 12, 0);
      if (sv && *sv)
	quant->tr_threshold = SvIV(*sv);
    }
    if (quant->transp == tr_errdiff) {
      sv = hv_fetch(hv, "tr_errdiff", 10, 0);
      if (sv && *sv && (str = SvPV(*sv, len)))
	quant->tr_errdiff = lookup_name(errdiff_names, sizeof(errdiff_names)/sizeof(*errdiff_names), str, ed_floyd);
    }
    if (quant->transp == tr_ordered) {
      quant->tr_orddith = od_tiny;
      sv = hv_fetch(hv, "tr_orddith", 10, 0);
      if (sv && *sv && (str = SvPV(*sv, len)))
	quant->tr_orddith = lookup_name(orddith_names, sizeof(orddith_names)/sizeof(*orddith_names), str, od_random);

      if (quant->tr_orddith == od_custom) {
	sv = hv_fetch(hv, "tr_map", 6, 0);
	if (sv && *sv && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
	  AV *av = (AV*)SvRV(*sv);
	  len = av_len(av) + 1;
	  if (len > sizeof(quant->tr_custom))
	    len = sizeof(quant->tr_custom);
	  for (i = 0; i < len; ++i) {
	    SV **sv2 = av_fetch(av, i, 0);
	    if (sv2 && *sv2) {
	      quant->tr_custom[i] = SvIV(*sv2);
	    }
	  }
	  while (i < sizeof(quant->tr_custom))
	    quant->tr_custom[i++] = 0;
	}
      }
    }
  }
  quant->make_colors = mc_median_cut;
  sv = hv_fetch(hv, "make_colors", 11, 0);
  if (sv && *sv && (str = SvPV(*sv, len))) {
    quant->make_colors = 
      lookup_name(make_color_names, sizeof(make_color_names)/sizeof(*make_color_names), str, mc_median_cut);
  }
  sv = hv_fetch(hv, "colors", 6, 0);
  if (sv && *sv && SvROK(*sv) && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
    /* needs to be an array of Imager::Color
       note that the caller allocates the mc_color array and sets mc_size
       to it's size */
    AV *av = (AV *)SvRV(*sv);
    quant->mc_count = av_len(av)+1;
    if (quant->mc_count > quant->mc_size)
      quant->mc_count = quant->mc_size;
    for (i = 0; i < quant->mc_count; ++i) {
      SV **sv1 = av_fetch(av, i, 0);
      if (sv1 && *sv1 && SvROK(*sv1) && sv_derived_from(*sv1, "Imager::Color")) {
	i_color *col = INT2PTR(i_color *, SvIV((SV*)SvRV(*sv1)));
	quant->mc_colors[i] = *col;
      }
    }
  }
  sv = hv_fetch(hv, "max_colors", 10, 0);
  if (sv && *sv) {
    i = SvIV(*sv);
    if (i <= quant->mc_size && i >= quant->mc_count)
      quant->mc_size = i;
  }

  quant->translate = pt_closest;
  sv = hv_fetch(hv, "translate", 9, 0);
  if (sv && *sv && (str = SvPV(*sv, len))) {
    quant->translate = lookup_name(translate_names, sizeof(translate_names)/sizeof(*translate_names), str, pt_closest);
  }
  sv = hv_fetch(hv, "errdiff", 7, 0);
  if (sv && *sv && (str = SvPV(*sv, len))) {
    quant->errdiff = lookup_name(errdiff_names, sizeof(errdiff_names)/sizeof(*errdiff_names), str, ed_floyd);
  }
  if (quant->translate == pt_errdiff && quant->errdiff == ed_custom) {
    /* get the error diffusion map */
    sv = hv_fetch(hv, "errdiff_width", 13, 0);
    if (sv && *sv)
      quant->ed_width = SvIV(*sv);
    sv = hv_fetch(hv, "errdiff_height", 14, 0);
    if (sv && *sv)
      quant->ed_height = SvIV(*sv);
    sv = hv_fetch(hv, "errdiff_orig", 12, 0);
    if (sv && *sv)
      quant->ed_orig = SvIV(*sv);
    if (quant->ed_width > 0 && quant->ed_height > 0) {
      int sum = 0;
      quant->ed_map = mymalloc(sizeof(int)*quant->ed_width*quant->ed_height);
      sv = hv_fetch(hv, "errdiff_map", 11, 0);
      if (sv && *sv && SvROK(*sv) && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
	AV *av = (AV*)SvRV(*sv);
	len = av_len(av) + 1;
	if (len > quant->ed_width * quant->ed_height)
	  len = quant->ed_width * quant->ed_height;
	for (i = 0; i < len; ++i) {
	  SV **sv2 = av_fetch(av, i, 0);
	  if (sv2 && *sv2) {
	    quant->ed_map[i] = SvIV(*sv2);
	    sum += quant->ed_map[i];
	  }
	}
      }
      if (!sum) {
	/* broken map */
	myfree(quant->ed_map);
	quant->ed_map = 0;
	quant->errdiff = ed_floyd;
      }
    }
  }
  sv = hv_fetch(hv, "perturb", 7, 0);
  if (sv && *sv)
    quant->perturb = SvIV(*sv);
}

static void
ip_cleanup_quant_opts(pTHX_ i_quantize *quant) {
  myfree(quant->mc_colors);
  if (quant->ed_map)
    myfree(quant->ed_map);
}

/* copies the color map from the hv into the colors member of the HV */
static void
ip_copy_colors_back(pTHX_ HV *hv, i_quantize *quant) {
  SV **sv;
  AV *av;
  int i;
  SV *work;

  sv = hv_fetch(hv, "colors", 6, 0);
  if (!sv || !*sv || !SvROK(*sv) || SvTYPE(SvRV(*sv)) != SVt_PVAV) {
    /* nothing to do */
    return;
  }

  av = (AV *)SvRV(*sv);
  av_clear(av);
  av_extend(av, quant->mc_count+1);
  for (i = 0; i < quant->mc_count; ++i) {
    i_color *in = quant->mc_colors+i;
    Imager__Color c = ICL_new_internal(in->rgb.r, in->rgb.g, in->rgb.b, 255);
    work = sv_newmortal();
    sv_setref_pv(work, "Imager::Color", (void *)c);
    SvREFCNT_inc(work);
    av_push(av, work);
  }
}

/* loads the segments of a fountain fill into an array */
static i_fountain_seg *
load_fount_segs(pTHX_ AV *asegs, int *count) {
  /* Each element of segs must contain:
     [ start, middle, end, c0, c1, segtype, colortrans ]
     start, middle, end are doubles from 0 to 1
     c0, c1 are Imager::Color::Float or Imager::Color objects
     segtype, colortrans are ints
  */
  int i, j;
  AV *aseg;
  i_fountain_seg *segs;
  double work[3];
  int worki[2];

  *count = av_len(asegs)+1;
  if (*count < 1) 
    croak("i_fountain must have at least one segment");
  segs = mymalloc(sizeof(i_fountain_seg) * *count);
  for(i = 0; i < *count; i++) {
    SV **sv1 = av_fetch(asegs, i, 0);
    if (!sv1 || !*sv1 || !SvROK(*sv1) 
        || SvTYPE(SvRV(*sv1)) != SVt_PVAV) {
      myfree(segs);
      croak("i_fountain: segs must be an arrayref of arrayrefs");
    }
    aseg = (AV *)SvRV(*sv1);
    if (av_len(aseg) != 7-1) {
      myfree(segs);
      croak("i_fountain: a segment must have 7 members");
    }
    for (j = 0; j < 3; ++j) {
      SV **sv2 = av_fetch(aseg, j, 0);
      if (!sv2 || !*sv2) {
        myfree(segs);
        croak("i_fountain: XS error");
      }
      work[j] = SvNV(*sv2);
    }
    segs[i].start  = work[0];
    segs[i].middle = work[1];
    segs[i].end    = work[2];
    for (j = 0; j < 2; ++j) {
      SV **sv3 = av_fetch(aseg, 3+j, 0);
      if (!sv3 || !*sv3 || !SvROK(*sv3) ||
          (!sv_derived_from(*sv3, "Imager::Color")
           && !sv_derived_from(*sv3, "Imager::Color::Float"))) {
        myfree(segs);
        croak("i_fountain: segs must contain colors in elements 3 and 4");
      }
      if (sv_derived_from(*sv3, "Imager::Color::Float")) {
        segs[i].c[j] = *INT2PTR(i_fcolor *, SvIV((SV *)SvRV(*sv3)));
      }
      else {
        i_color c = *INT2PTR(i_color *, SvIV((SV *)SvRV(*sv3)));
        int ch;
        for (ch = 0; ch < MAXCHANNELS; ++ch) {
          segs[i].c[j].channel[ch] = c.channel[ch] / 255.0;
        }
      }
    }
    for (j = 0; j < 2; ++j) {
      SV **sv2 = av_fetch(aseg, j+5, 0);
      if (!sv2 || !*sv2) {
        myfree(segs);
        croak("i_fountain: XS error");
      }
      worki[j] = SvIV(*sv2);
    }
    segs[i].type = worki[0];
    segs[i].color = worki[1];
  }

  return segs;
}

/* validates the indexes supplied to i_ppal

i_ppal() doesn't do that for speed, but I'm not comfortable doing that
for calls from perl.

*/
static void
validate_i_ppal(i_img *im, i_palidx const *indexes, int count) {
  int color_count = i_colorcount(im);
  int i;

  if (color_count == -1)
    croak("i_plin() called on direct color image");
  
  for (i = 0; i < count; ++i) {
    if (indexes[i] >= color_count) {
      croak("i_plin() called with out of range color index %d (max %d)",
        indexes[i], color_count-1);
    }
  }
}


/* I don't think ICLF_* names belong at the C interface
   this makes the XS code think we have them, to let us avoid 
   putting function bodies in the XS code
*/
#define ICLF_new_internal(r, g, b, a) i_fcolor_new((r), (g), (b), (a))
#define ICLF_DESTROY(cl) i_fcolor_destroy(cl)

#ifdef IMAGER_LOG
#define i_log_enabled() 1
#else
#define i_log_enabled() 0
#endif

#if i_int_hlines_testing()

typedef i_int_hlines *Imager__Internal__Hlines;

static i_int_hlines *
i_int_hlines_new(i_img_dim start_y, i_img_dim count_y, i_img_dim start_x, i_img_dim count_x) {
  i_int_hlines *result = mymalloc(sizeof(i_int_hlines));
  i_int_init_hlines(result, start_y, count_y, start_x, count_x);

  return result;
}

static i_int_hlines *
i_int_hlines_new_img(i_img *im) {
  i_int_hlines *result = mymalloc(sizeof(i_int_hlines));
  i_int_init_hlines_img(result, im);

  return result;
}

static void
i_int_hlines_DESTROY(i_int_hlines *hlines) {
  i_int_hlines_destroy(hlines);
  myfree(hlines);
}

#define i_int_hlines_CLONE_SKIP(cls) 1

static int seg_compare(const void *vleft, const void *vright) {
  const i_int_hline_seg *left = vleft;
  const i_int_hline_seg *right = vright;

  return left->minx - right->minx;
}

static SV *
i_int_hlines_dump(i_int_hlines *hlines) {
  dTHX;
  SV *dump = newSVpvf("start_y: %" i_DF " limit_y: %" i_DF " start_x: %" i_DF " limit_x: %" i_DF"\n",
	i_DFc(hlines->start_y), i_DFc(hlines->limit_y), i_DFc(hlines->start_x), i_DFc(hlines->limit_x));
  i_img_dim y;
  
  for (y = hlines->start_y; y < hlines->limit_y; ++y) {
    i_int_hline_entry *entry = hlines->entries[y-hlines->start_y];
    if (entry) {
      int i;
      /* sort the segments, if any */
      if (entry->count)
        qsort(entry->segs, entry->count, sizeof(i_int_hline_seg), seg_compare);

      sv_catpvf(dump, " %" i_DF " (%" i_DF "):", i_DFc(y), i_DFc(entry->count));
      for (i = 0; i < entry->count; ++i) {
        sv_catpvf(dump, " [%" i_DF ", %" i_DF ")", i_DFc(entry->segs[i].minx), 
                  i_DFc(entry->segs[i].x_limit));
      }
      sv_catpv(dump, "\n");
    }
  }

  return dump;
}

#endif

static off_t
i_sv_off_t(pTHX_ SV *sv) {
#if LSEEKSIZE > IVSIZE
  return (off_t)SvNV(sv);
#else
  return (off_t)SvIV(sv);
#endif
}

static SV *
i_new_sv_off_t(pTHX_ off_t off) {
#if LSEEKSIZE > IVSIZE
  return newSVnv(off);
#else
  return newSViv(off);
#endif
}

static im_pl_ext_funcs im_perl_funcs =
{
  IMAGER_PL_API_VERSION,
  IMAGER_PL_API_LEVEL,
  ip_handle_quant_opts,
  ip_cleanup_quant_opts,
  ip_copy_colors_back
};

#define PERL_PL_SET_GLOBAL_CALLBACKS \
  sv_setiv(get_sv(PERL_PL_FUNCTION_TABLE_NAME, 1), PTR2IV(&im_perl_funcs));

#define IIM_new i_img_8_new
#define IIM_DESTROY i_img_destroy

#ifdef IMEXIF_ENABLE
#define i_exif_enabled() 1
#else
#define i_exif_enabled() 0
#endif

/* trying to use more C style names, map them here */
#define i_io_DESTROY(ig) io_glue_destroy(ig)

#define i_img_get_width(im) ((im)->xsize)
#define i_img_get_height(im) ((im)->ysize)

#define i_img_epsilonf() (DBL_EPSILON * 4)

/* avoid some xsubpp strangeness */
#define NEWLINE '\n'

#line 868 "Imager.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 920 "Imager.c"

XS(XS_Imager__Color_new_internal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color_new_internal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "r, g, b, a");
    {
	unsigned char	r = (unsigned char)SvUV(ST(0));
	unsigned char	g = (unsigned char)SvUV(ST(1));
	unsigned char	b = (unsigned char)SvUV(ST(2));
	unsigned char	a = (unsigned char)SvUV(ST(3));
	Imager__Color	RETVAL;

	RETVAL = ICL_new_internal(r, g, b, a);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Color", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__Color_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cl");
    {
	Imager__Color	cl;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Imager::Color::DESTROY",
			"cl");

	ICL_DESTROY(cl);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager__Color_set_internal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color_set_internal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "cl, r, g, b, a");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__Color	cl;
	unsigned char	r = (unsigned char)SvUV(ST(1));
	unsigned char	g = (unsigned char)SvUV(ST(2));
	unsigned char	b = (unsigned char)SvUV(ST(3));
	unsigned char	a = (unsigned char)SvUV(ST(4));

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Color::set_internal",
			"cl", "Imager::Color");
#line 880 "Imager.xs"
	       ICL_set_internal(cl, r, g, b, a);
	       EXTEND(SP, 1);
	       PUSHs(ST(0));
#line 1006 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager__Color_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cl");
    {
	Imager__Color	cl;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Color::info",
			"cl", "Imager::Color");

	ICL_info(cl);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager__Color_rgba); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color_rgba)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cl");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__Color	cl;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Color::rgba",
			"cl", "Imager::Color");
#line 893 "Imager.xs"
		EXTEND(SP, 4);
		PUSHs(sv_2mortal(newSVnv(cl->rgba.r)));
		PUSHs(sv_2mortal(newSVnv(cl->rgba.g)));
		PUSHs(sv_2mortal(newSVnv(cl->rgba.b)));
		PUSHs(sv_2mortal(newSVnv(cl->rgba.a)));
#line 1070 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager__Color_i_hsv_to_rgb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color_i_hsv_to_rgb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "c");
    {
	Imager__Color	c;
	Imager__Color	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    c = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Color::i_hsv_to_rgb",
			"c", "Imager::Color");
#line 903 "Imager.xs"
        RETVAL = mymalloc(sizeof(i_color));
        *RETVAL = *c;
        i_hsv_to_rgb(RETVAL);
#line 1103 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Color", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__Color_i_rgb_to_hsv); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color_i_rgb_to_hsv)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "c");
    {
	Imager__Color	c;
	Imager__Color	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    c = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Color::i_rgb_to_hsv",
			"c", "Imager::Color");
#line 913 "Imager.xs"
        RETVAL = mymalloc(sizeof(i_color));
        *RETVAL = *c;
        i_rgb_to_hsv(RETVAL);
#line 1137 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Color", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__Color__Float_new_internal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color__Float_new_internal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "r, g, b, a");
    {
	double	r = (double)SvNV(ST(0));
	double	g = (double)SvNV(ST(1));
	double	b = (double)SvNV(ST(2));
	double	a = (double)SvNV(ST(3));
	Imager__Color__Float	RETVAL;

	RETVAL = ICLF_new_internal(r, g, b, a);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Color::Float", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__Color__Float_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color__Float_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cl");
    {
	Imager__Color__Float	cl;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = INT2PTR(Imager__Color__Float,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Imager::Color::Float::DESTROY",
			"cl");

	ICLF_DESTROY(cl);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager__Color__Float_rgba); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color__Float_rgba)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cl");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__Color__Float	cl;
#line 938 "Imager.xs"
        int ch;
#line 1214 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = INT2PTR(Imager__Color__Float,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Color::Float::rgba",
			"cl", "Imager::Color::Float");
#line 940 "Imager.xs"
        EXTEND(SP, MAXCHANNELS);
        for (ch = 0; ch < MAXCHANNELS; ++ch) {
        /* printf("%d: %g\n", ch, cl->channel[ch]); */
          PUSHs(sv_2mortal(newSVnv(cl->channel[ch])));
        }
#line 1230 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager__Color__Float_set_internal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color__Float_set_internal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "cl, r, g, b, a");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__Color__Float	cl;
	double	r = (double)SvNV(ST(1));
	double	g = (double)SvNV(ST(2));
	double	b = (double)SvNV(ST(3));
	double	a = (double)SvNV(ST(4));

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = INT2PTR(Imager__Color__Float,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Color::Float::set_internal",
			"cl", "Imager::Color::Float");
#line 954 "Imager.xs"
        cl->rgba.r = r;
        cl->rgba.g = g;
        cl->rgba.b = b;
        cl->rgba.a = a;                
        EXTEND(SP, 1);
        PUSHs(ST(0));
#line 1271 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager__Color__Float_i_hsv_to_rgb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color__Float_i_hsv_to_rgb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "c");
    {
	Imager__Color__Float	c;
	Imager__Color__Float	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    c = INT2PTR(Imager__Color__Float,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Color::Float::i_hsv_to_rgb",
			"c", "Imager::Color::Float");
#line 965 "Imager.xs"
        RETVAL = mymalloc(sizeof(i_fcolor));
        *RETVAL = *c;
        i_hsv_to_rgbf(RETVAL);
#line 1304 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Color::Float", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__Color__Float_i_rgb_to_hsv); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Color__Float_i_rgb_to_hsv)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "c");
    {
	Imager__Color__Float	c;
	Imager__Color__Float	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    c = INT2PTR(Imager__Color__Float,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Color::Float::i_rgb_to_hsv",
			"c", "Imager::Color::Float");
#line 975 "Imager.xs"
        RETVAL = mymalloc(sizeof(i_fcolor));
        *RETVAL = *c;
        i_rgb_to_hsvf(RETVAL);
#line 1338 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Color::Float", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__ImgRaw_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__ImgRaw_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "x, y, ch");
    {
	i_img_dim	x = (i_img_dim)SvIV(ST(0));
	i_img_dim	y = (i_img_dim)SvIV(ST(1));
	int	ch = (int)SvIV(ST(2));
	Imager__ImgRaw	RETVAL;

	RETVAL = IIM_new(x, y, ch);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager__ImgRaw_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__ImgRaw_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	IIM_DESTROY(im);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_io_new_fd); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_io_new_fd)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0));
	Imager__IO	RETVAL;

	RETVAL = io_new_fd(fd);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::IO", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_io_new_bufchain); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_io_new_bufchain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Imager__IO	RETVAL;

	RETVAL = io_new_bufchain();
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::IO", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_io_new_buffer); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_io_new_buffer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "data_sv");
    {
	SV *	data_sv = ST(0);
	Imager__IO	RETVAL;
#line 1012 "Imager.xs"
	  RETVAL = do_io_new_buffer(aTHX_ data_sv);
#line 1466 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::IO", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_io_new_cb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_io_new_cb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "writecb, readcb, seekcb, closecb, maxwrite = CBDATA_BUFSIZE");
    {
	SV *	writecb = ST(0);
	SV *	readcb = ST(1);
	SV *	seekcb = ST(2);
	SV *	closecb = ST(3);
	int	maxwrite;
	Imager__IO	RETVAL;

	if (items < 5)
	    maxwrite = CBDATA_BUFSIZE;
	else {
	    maxwrite = (int)SvIV(ST(4));
	}
#line 1024 "Imager.xs"
        RETVAL = do_io_new_cb(aTHX_ writecb, readcb, seekcb, closecb);
#line 1499 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::IO", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_io_slurp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_io_slurp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ig");
    {
	Imager__IO	ig;
#line 1032 "Imager.xs"
	      unsigned char*    data;
	      size_t    tlength;
#line 1522 "Imager.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::io_slurp",
			"ig", "Imager::IO");
#line 1035 "Imager.xs"
 	      data    = NULL;
              tlength = io_slurp(ig, &data);
              RETVAL = newSVpv((char *)data,tlength);
              myfree(data);
#line 1538 "Imager.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager_i_set_image_file_limits); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_set_image_file_limits)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "width, height, bytes");
    {
	i_img_dim	width = (i_img_dim)SvIV(ST(0));
	i_img_dim	height = (i_img_dim)SvIV(ST(1));
	size_t	bytes = (size_t)SvUV(ST(2));
	undef_int	RETVAL;

	RETVAL = i_set_image_file_limits(width, height, bytes);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_get_image_file_limits); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_get_image_file_limits)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1052 "Imager.xs"
        i_img_dim width, height;
	size_t bytes;
#line 1587 "Imager.c"
#line 1055 "Imager.xs"
        if (i_get_image_file_limits(&width, &height, &bytes)) {
	  EXTEND(SP, 3);
          PUSHs(sv_2mortal(newSViv(width)));
          PUSHs(sv_2mortal(newSViv(height)));
          PUSHs(sv_2mortal(newSVuv(bytes)));
        }
#line 1595 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_int_check_image_file_limits); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_int_check_image_file_limits)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "width, height, channels, sample_size");
    {
	i_img_dim	width = (i_img_dim)SvIV(ST(0));
	i_img_dim	height = (i_img_dim)SvIV(ST(1));
	int	channels = (int)SvIV(ST(2));
	size_t	sample_size = (size_t)SvUV(ST(3));
	bool	RETVAL;

	RETVAL = i_int_check_image_file_limits(width, height, channels, sample_size);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_new_fd); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_new_fd)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "class, fd");
    {
	int	fd = (int)SvIV(ST(1));
	Imager__IO	RETVAL;
#line 1076 "Imager.xs"
	RETVAL = io_new_fd(fd);
#line 1642 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::IO", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_new_buffer); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_new_buffer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "class, data_sv");
    {
	SV *	data_sv = ST(1);
	Imager__IO	RETVAL;
#line 1084 "Imager.xs"
        RETVAL = do_io_new_buffer(aTHX_ data_sv);
#line 1665 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::IO", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_new_cb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_new_cb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "class, writecb, readcb, seekcb, closecb");
    {
	SV *	writecb = ST(1);
	SV *	readcb = ST(2);
	SV *	seekcb = ST(3);
	SV *	closecb = ST(4);
	Imager__IO	RETVAL;
#line 1095 "Imager.xs"
        RETVAL = do_io_new_cb(aTHX_ writecb, readcb, seekcb, closecb);
#line 1691 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::IO", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_new_bufchain); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_new_bufchain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	Imager__IO	RETVAL;
#line 1102 "Imager.xs"
	RETVAL = io_new_bufchain();
#line 1713 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::IO", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_slurp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_slurp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "class, ig");
    {
	Imager__IO	ig;
#line 1110 "Imager.xs"
	unsigned char*    data;
	size_t    tlength;
#line 1736 "Imager.c"
	SV *	RETVAL;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::slurp",
			"ig", "Imager::IO");
#line 1113 "Imager.xs"
	data    = NULL;
	tlength = io_slurp(ig, &data);
	RETVAL = newSVpv((char *)data,tlength);
	myfree(data);
#line 1752 "Imager.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_raw_write); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_raw_write)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ig, data_sv");
    {
	Imager__IO	ig;
	SV *	data_sv = ST(1);
#line 1127 "Imager.xs"
        void *data;
	STRLEN size;
#line 1776 "Imager.c"
	IV	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::raw_write",
			"ig", "Imager::IO");
#line 1130 "Imager.xs"
#ifdef SvUTF8
        if (SvUTF8(data_sv)) {
	  data_sv = sv_2mortal(newSVsv(data_sv));
          /* yes, we want this to croak() if the SV can't be downgraded */
	  sv_utf8_downgrade(data_sv, FALSE);
	}
#endif        
	data = SvPV(data_sv, size);
        RETVAL = i_io_raw_write(ig, data, size);
#line 1798 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_raw_read); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_raw_read)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "ig, buffer_sv, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__IO	ig;
	SV *	buffer_sv = ST(1);
	IV	size = (IV)SvIV(ST(2));
#line 1148 "Imager.xs"
        void *buffer;
	ssize_t result;
#line 1824 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::raw_read",
			"ig", "Imager::IO");
#line 1151 "Imager.xs"
        if (size <= 0)
	  croak("size negative in call to i_io_raw_read()");
        /* prevent an undefined value warning if they supplied an 
	   undef buffer.
           Orginally conditional on !SvOK(), but this will prevent the
	   downgrade from croaking */
	sv_setpvn(buffer_sv, "", 0);
#ifdef SvUTF8
	if (SvUTF8(buffer_sv))
          sv_utf8_downgrade(buffer_sv, FALSE);
#endif
	buffer = SvGROW(buffer_sv, size+1);
        result = i_io_raw_read(ig, buffer, size);
        if (result >= 0) {
	  SvCUR_set(buffer_sv, result);
	  *SvEND(buffer_sv) = '\0';
	  SvPOK_only(buffer_sv);
	  EXTEND(SP, 1);
	  PUSHs(sv_2mortal(newSViv(result)));
	}
	ST(1) = buffer_sv;
	SvSETMAGIC(ST(1));
#line 1857 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager__IO_raw_read2); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_raw_read2)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ig, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__IO	ig;
	IV	size = (IV)SvIV(ST(1));
#line 1179 "Imager.xs"
	SV *buffer_sv;
        void *buffer;
	ssize_t result;
#line 1883 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::raw_read2",
			"ig", "Imager::IO");
#line 1183 "Imager.xs"
        if (size <= 0)
	  croak("size negative in call to i_io_read2()");
	buffer_sv = newSV(size);
	buffer = SvGROW(buffer_sv, size+1);
        result = i_io_raw_read(ig, buffer, size);
        if (result >= 0) {
	  SvCUR_set(buffer_sv, result);
	  *SvEND(buffer_sv) = '\0';
	  SvPOK_only(buffer_sv);
	  EXTEND(SP, 1);
	  PUSHs(sv_2mortal(buffer_sv));
	}
	else {
          /* discard it */
	  SvREFCNT_dec(buffer_sv);
        }
#line 1910 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager__IO_raw_seek); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_raw_seek)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "ig, position, whence");
    {
	Imager__IO	ig;
	off_t  position = i_sv_off_t(aTHX_ ST(1));
	int	whence = (int)SvIV(ST(2));
	off_t	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::raw_seek",
			"ig", "Imager::IO");

	RETVAL = i_io_raw_seek(ig, position, whence);
	ST(0) = i_new_sv_off_t(aTHX_ RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_raw_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_raw_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ig");
    {
	Imager__IO	ig;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::raw_close",
			"ig", "Imager::IO");

	RETVAL = i_io_raw_close(ig);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ig");
    {
	Imager__IO	ig;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Imager::IO::DESTROY",
			"ig");

	i_io_DESTROY(ig);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager__IO_CLONE_SKIP); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_CLONE_SKIP)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1217 "Imager.xs"
        (void)items; /* avoid unused warning for XS variable */
	RETVAL = 1;
#line 2024 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_getc); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_getc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ig");
    {
	Imager__IO	ig;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::getc",
			"ig", "Imager::IO");

	RETVAL = i_io_getc(ig);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_putc); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_putc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ig, c");
    {
	Imager__IO	ig;
	int	c = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::putc",
			"ig", "Imager::IO");

	RETVAL = i_io_putc(ig, c);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ig");
    {
	Imager__IO	ig;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::close",
			"ig", "Imager::IO");

	RETVAL = i_io_close(ig);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_flush)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ig");
    {
	Imager__IO	ig;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::flush",
			"ig", "Imager::IO");

	RETVAL = i_io_flush(ig);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_peekc); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_peekc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ig");
    {
	Imager__IO	ig;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::peekc",
			"ig", "Imager::IO");

	RETVAL = i_io_peekc(ig);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_seek); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_seek)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "ig, off, whence");
    {
	Imager__IO	ig;
	off_t  off = i_sv_off_t(aTHX_ ST(1));
	int	whence = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::seek",
			"ig", "Imager::IO");

	RETVAL = i_io_seek(ig, off, whence);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_peekn); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_peekn)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ig, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__IO	ig;
	STRLEN	size = (STRLEN)SvUV(ST(1));
#line 1254 "Imager.xs"
	SV *buffer_sv;
        void *buffer;
	ssize_t result;
#line 2239 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::peekn",
			"ig", "Imager::IO");
#line 1258 "Imager.xs"
	buffer_sv = newSV(size+1);
	buffer = SvGROW(buffer_sv, size+1);
        result = i_io_peekn(ig, buffer, size);
        if (result >= 0) {
	  SvCUR_set(buffer_sv, result);
	  *SvEND(buffer_sv) = '\0';
	  SvPOK_only(buffer_sv);
	  EXTEND(SP, 1);
	  PUSHs(sv_2mortal(buffer_sv));
	}
	else {
          /* discard it */
	  SvREFCNT_dec(buffer_sv);
        }
#line 2264 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager__IO_read); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_read)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "ig, buffer_sv, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__IO	ig;
	SV *	buffer_sv = ST(1);
	IV	size = (IV)SvIV(ST(2));
#line 1279 "Imager.xs"
        void *buffer;
	ssize_t result;
#line 2290 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::read",
			"ig", "Imager::IO");
#line 1282 "Imager.xs"
        if (size <= 0)
	  croak("size negative in call to i_io_read()");
        /* prevent an undefined value warning if they supplied an 
	   undef buffer.
           Orginally conditional on !SvOK(), but this will prevent the
	   downgrade from croaking */
	sv_setpvn(buffer_sv, "", 0);
#ifdef SvUTF8
	if (SvUTF8(buffer_sv))
          sv_utf8_downgrade(buffer_sv, FALSE);
#endif
	buffer = SvGROW(buffer_sv, size+1);
        result = i_io_read(ig, buffer, size);
        if (result >= 0) {
	  SvCUR_set(buffer_sv, result);
	  *SvEND(buffer_sv) = '\0';
	  SvPOK_only(buffer_sv);
	  EXTEND(SP, 1);
	  PUSHs(sv_2mortal(newSViv(result)));
	}
	ST(1) = buffer_sv;
	SvSETMAGIC(ST(1));
#line 2323 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager__IO_read2); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_read2)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ig, size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__IO	ig;
	STRLEN	size = (STRLEN)SvUV(ST(1));
#line 1310 "Imager.xs"
	SV *buffer_sv;
        void *buffer;
	ssize_t result;
#line 2349 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::read2",
			"ig", "Imager::IO");
#line 1314 "Imager.xs"
        if (size == 0)
	  croak("size zero in call to read2()");
	buffer_sv = newSV(size);
	buffer = SvGROW(buffer_sv, size+1);
        result = i_io_read(ig, buffer, size);
        if (result > 0) {
	  SvCUR_set(buffer_sv, result);
	  *SvEND(buffer_sv) = '\0';
	  SvPOK_only(buffer_sv);
	  EXTEND(SP, 1);
	  PUSHs(sv_2mortal(buffer_sv));
	}
	else {
          /* discard it */
	  SvREFCNT_dec(buffer_sv);
        }
#line 2376 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager__IO_gets); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_gets)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "ig, size = 8192, eol = NEWLINE");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__IO	ig;
	STRLEN	size;
	int	eol;
#line 1337 "Imager.xs"
	SV *buffer_sv;
        void *buffer;
	ssize_t result;
#line 2403 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::gets",
			"ig", "Imager::IO");

	if (items < 2)
	    size = 8192;
	else {
	    size = (STRLEN)SvUV(ST(1));
	}

	if (items < 3)
	    eol = NEWLINE;
	else {
	    eol = (int)SvIV(ST(2));
	}
#line 1341 "Imager.xs"
        if (size < 2)
	  croak("size too small in call to gets()");
	buffer_sv = sv_2mortal(newSV(size+1));
	buffer = SvPVX(buffer_sv);
        result = i_io_gets(ig, buffer, size+1, eol);
        if (result > 0) {
	  SvCUR_set(buffer_sv, result);
	  *SvEND(buffer_sv) = '\0';
	  SvPOK_only(buffer_sv);
	  EXTEND(SP, 1);
	  PUSHs(buffer_sv);
	}
#line 2438 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager__IO_write); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_write)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ig, data_sv");
    {
	Imager__IO	ig;
	SV *	data_sv = ST(1);
#line 1359 "Imager.xs"
        void *data;
	STRLEN size;
#line 2461 "Imager.c"
	IV	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::write",
			"ig", "Imager::IO");
#line 1362 "Imager.xs"
#ifdef SvUTF8
        if (SvUTF8(data_sv)) {
	  data_sv = sv_2mortal(newSVsv(data_sv));
          /* yes, we want this to croak() if the SV can't be downgraded */
	  sv_utf8_downgrade(data_sv, FALSE);
	}
#endif        
	data = SvPV(data_sv, size);
        RETVAL = i_io_write(ig, data, size);
#line 2483 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_dump); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_dump)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "ig, flags = I_IO_DUMP_DEFAULT");
    {
	Imager__IO	ig;
	int	flags;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::dump",
			"ig", "Imager::IO");

	if (items < 2)
	    flags = I_IO_DUMP_DEFAULT;
	else {
	    flags = (int)SvIV(ST(1));
	}

	i_io_dump(ig, flags);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager__IO_set_buffered); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_set_buffered)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "ig, flag = 1");
    {
	Imager__IO	ig;
	int	flag;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::set_buffered",
			"ig", "Imager::IO");

	if (items < 2)
	    flag = 1;
	else {
	    flag = (int)SvIV(ST(1));
	}

	RETVAL = i_io_set_buffered(ig, flag);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_is_buffered); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_is_buffered)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ig");
    {
	Imager__IO	ig;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::is_buffered",
			"ig", "Imager::IO");

	RETVAL = i_io_is_buffered(ig);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_eof); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_eof)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ig");
    {
	Imager__IO	ig;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::eof",
			"ig", "Imager::IO");

	RETVAL = i_io_eof(ig);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager__IO_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__IO_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "ig");
    {
	Imager__IO	ig;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::IO::error",
			"ig", "Imager::IO");

	RETVAL = i_io_error(ig);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager_i_list_formats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_list_formats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1403 "Imager.xs"
	      char*    item;
	       int     i;
#line 2672 "Imager.c"
#line 1406 "Imager.xs"
	       i=0;
	       while( (item=i_format_list[i++]) != NULL ) {
		      EXTEND(SP, 1);
		      PUSHs(sv_2mortal(newSVpv(item,0)));
	       }
#line 2679 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_sametype); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_sametype)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "im, x, y");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_sametype(im, x, y);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_sametype_chans); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_sametype_chans)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, x, y, channels");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	int	channels = (int)SvIV(ST(3));
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_sametype_chans(im, x, y, channels);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_init_log); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_init_log)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "name_sv, level");
    {
	SV*	name_sv = ST(0);
	int	level = (int)SvIV(ST(1));
#line 1430 "Imager.xs"
	  const char *name = SvOK(name_sv) ? SvPV_nolen(name_sv) : NULL;
#line 2788 "Imager.c"
	int	RETVAL;
	dXSTARG;
#line 1432 "Imager.xs"
	  RETVAL = i_init_log(name, level);
#line 2793 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_log_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_log_entry)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "string, level");
    {
	char*	string = (char *)SvPV_nolen(ST(0));
	int	level = (int)SvIV(ST(1));

	i_log_entry(string, level);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_log_enabled); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_log_enabled)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = i_log_enabled();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
#line 1448 "Imager.xs"
	       i_img_dim     info[4];
#line 2857 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 1450 "Imager.xs"
   	       i_img_info(im,info);
               EXTEND(SP, 4);
               PUSHs(sv_2mortal(newSViv(info[0])));
               PUSHs(sv_2mortal(newSViv(info[1])));
               PUSHs(sv_2mortal(newSViv(info[2])));
               PUSHs(sv_2mortal(newSViv(info[3])));
#line 2883 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_img_setmask); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_setmask)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, ch_mask");
    {
	Imager__ImgRaw	im;
	int	ch_mask = (int)SvIV(ST(1));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_img_setmask(im, ch_mask);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_img_getmask); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_getmask)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_img_getmask(im);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_getchannels); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_getchannels)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_img_getchannels(im);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_getdata); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_getdata)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 1477 "Imager.xs"
	       EXTEND(SP, 1);
               PUSHs(im->idata ? 
	             sv_2mortal(newSVpv((char *)im->idata, im->bytes)) 
		     : &PL_sv_undef);
#line 3045 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_img_get_width); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_get_width)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	IV	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_img_get_width(im);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_get_height); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_get_height)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	IV	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_img_get_height(im);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_is_monochrome); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_is_monochrome)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
#line 1495 "Imager.xs"
	int zero_is_white;
	int result;
#line 3149 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 1498 "Imager.xs"
	result = i_img_is_monochrome(im, &zero_is_white);
	if (result) {
	  if (GIMME_V == G_ARRAY) {
	    EXTEND(SP, 2);
	    PUSHs(&PL_sv_yes);
	    PUSHs(sv_2mortal(newSViv(zero_is_white)));
 	  }
	  else {
	    EXTEND(SP, 1);
	    PUSHs(&PL_sv_yes);
	  }
	}
#line 3181 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_line); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_line)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "im, x1, y1, x2, y2, val, endp");
    {
	Imager__ImgRaw	im;
	i_img_dim	x1 = (i_img_dim)SvIV(ST(1));
	i_img_dim	y1 = (i_img_dim)SvIV(ST(2));
	i_img_dim	x2 = (i_img_dim)SvIV(ST(3));
	i_img_dim	y2 = (i_img_dim)SvIV(ST(4));
	Imager__Color	val;
	int	endp = (int)SvIV(ST(6));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(5)) && sv_derived_from(ST(5), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_line",
			"val", "Imager::Color");

	i_line(im, x1, y1, x2, y2, val, endp);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_line_aa); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_line_aa)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "im, x1, y1, x2, y2, val, endp");
    {
	Imager__ImgRaw	im;
	i_img_dim	x1 = (i_img_dim)SvIV(ST(1));
	i_img_dim	y1 = (i_img_dim)SvIV(ST(2));
	i_img_dim	x2 = (i_img_dim)SvIV(ST(3));
	i_img_dim	y2 = (i_img_dim)SvIV(ST(4));
	Imager__Color	val;
	int	endp = (int)SvIV(ST(6));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(5)) && sv_derived_from(ST(5), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_line_aa",
			"val", "Imager::Color");

	i_line_aa(im, x1, y1, x2, y2, val, endp);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_box); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_box)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "im, x1, y1, x2, y2, val");
    {
	Imager__ImgRaw	im;
	i_img_dim	x1 = (i_img_dim)SvIV(ST(1));
	i_img_dim	y1 = (i_img_dim)SvIV(ST(2));
	i_img_dim	x2 = (i_img_dim)SvIV(ST(3));
	i_img_dim	y2 = (i_img_dim)SvIV(ST(4));
	Imager__Color	val;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(5)) && sv_derived_from(ST(5), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_box",
			"val", "Imager::Color");

	i_box(im, x1, y1, x2, y2, val);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_box_filled); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_box_filled)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "im, x1, y1, x2, y2, val");
    {
	Imager__ImgRaw	im;
	i_img_dim	x1 = (i_img_dim)SvIV(ST(1));
	i_img_dim	y1 = (i_img_dim)SvIV(ST(2));
	i_img_dim	x2 = (i_img_dim)SvIV(ST(3));
	i_img_dim	y2 = (i_img_dim)SvIV(ST(4));
	Imager__Color	val;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(5)) && sv_derived_from(ST(5), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_box_filled",
			"val", "Imager::Color");

	i_box_filled(im, x1, y1, x2, y2, val);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_box_filledf); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_box_filledf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "im, x1, y1, x2, y2, val");
    {
	Imager__ImgRaw	im;
	i_img_dim	x1 = (i_img_dim)SvIV(ST(1));
	i_img_dim	y1 = (i_img_dim)SvIV(ST(2));
	i_img_dim	x2 = (i_img_dim)SvIV(ST(3));
	i_img_dim	y2 = (i_img_dim)SvIV(ST(4));
	Imager__Color__Float	val;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(5)) && sv_derived_from(ST(5), "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    val = INT2PTR(Imager__Color__Float,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_box_filledf",
			"val", "Imager::Color::Float");

	RETVAL = i_box_filledf(im, x1, y1, x2, y2, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_box_cfill); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_box_cfill)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "im, x1, y1, x2, y2, fill");
    {
	Imager__ImgRaw	im;
	i_img_dim	x1 = (i_img_dim)SvIV(ST(1));
	i_img_dim	y1 = (i_img_dim)SvIV(ST(2));
	i_img_dim	x2 = (i_img_dim)SvIV(ST(3));
	i_img_dim	y2 = (i_img_dim)SvIV(ST(4));
	Imager__FillHandle	fill;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(5)) && sv_derived_from(ST(5), "Imager::FillHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    fill = INT2PTR(Imager__FillHandle,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_box_cfill",
			"fill", "Imager::FillHandle");

	i_box_cfill(im, x1, y1, x2, y2, fill);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_arc); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_arc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "im, x, y, rad, d1, d2, val");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	double	rad = (double)SvNV(ST(3));
	double	d1 = (double)SvNV(ST(4));
	double	d2 = (double)SvNV(ST(5));
	Imager__Color	val;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(6)) && sv_derived_from(ST(6), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(6)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_arc",
			"val", "Imager::Color");

	i_arc(im, x, y, rad, d1, d2, val);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_arc_aa); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_arc_aa)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "im, x, y, rad, d1, d2, val");
    {
	Imager__ImgRaw	im;
	double	x = (double)SvNV(ST(1));
	double	y = (double)SvNV(ST(2));
	double	rad = (double)SvNV(ST(3));
	double	d1 = (double)SvNV(ST(4));
	double	d2 = (double)SvNV(ST(5));
	Imager__Color	val;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(6)) && sv_derived_from(ST(6), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(6)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_arc_aa",
			"val", "Imager::Color");

	i_arc_aa(im, x, y, rad, d1, d2, val);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_arc_cfill); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_arc_cfill)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "im, x, y, rad, d1, d2, fill");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	double	rad = (double)SvNV(ST(3));
	double	d1 = (double)SvNV(ST(4));
	double	d2 = (double)SvNV(ST(5));
	Imager__FillHandle	fill;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(6)) && sv_derived_from(ST(6), "Imager::FillHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(6)));
	    fill = INT2PTR(Imager__FillHandle,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_arc_cfill",
			"fill", "Imager::FillHandle");

	i_arc_cfill(im, x, y, rad, d1, d2, fill);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_arc_aa_cfill); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_arc_aa_cfill)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "im, x, y, rad, d1, d2, fill");
    {
	Imager__ImgRaw	im;
	double	x = (double)SvNV(ST(1));
	double	y = (double)SvNV(ST(2));
	double	rad = (double)SvNV(ST(3));
	double	d1 = (double)SvNV(ST(4));
	double	d2 = (double)SvNV(ST(5));
	Imager__FillHandle	fill;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(6)) && sv_derived_from(ST(6), "Imager::FillHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(6)));
	    fill = INT2PTR(Imager__FillHandle,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_arc_aa_cfill",
			"fill", "Imager::FillHandle");

	i_arc_aa_cfill(im, x, y, rad, d1, d2, fill);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_circle_aa); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_circle_aa)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, x, y, rad, val");
    {
	Imager__ImgRaw	im;
	double	x = (double)SvNV(ST(1));
	double	y = (double)SvNV(ST(2));
	double	rad = (double)SvNV(ST(3));
	Imager__Color	val;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(4)) && sv_derived_from(ST(4), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(4)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_circle_aa",
			"val", "Imager::Color");

	i_circle_aa(im, x, y, rad, val);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_circle_out); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_circle_out)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, x, y, rad, val");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	i_img_dim	rad = (i_img_dim)SvIV(ST(3));
	Imager__Color	val;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(4)) && sv_derived_from(ST(4), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(4)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_circle_out",
			"val", "Imager::Color");

	RETVAL = i_circle_out(im, x, y, rad, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_circle_out_aa); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_circle_out_aa)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, x, y, rad, val");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	i_img_dim	rad = (i_img_dim)SvIV(ST(3));
	Imager__Color	val;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(4)) && sv_derived_from(ST(4), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(4)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_circle_out_aa",
			"val", "Imager::Color");

	RETVAL = i_circle_out_aa(im, x, y, rad, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_arc_out); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_arc_out)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "im, x, y, rad, d1, d2, val");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	i_img_dim	rad = (i_img_dim)SvIV(ST(3));
	double	d1 = (double)SvNV(ST(4));
	double	d2 = (double)SvNV(ST(5));
	Imager__Color	val;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(6)) && sv_derived_from(ST(6), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(6)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_arc_out",
			"val", "Imager::Color");

	RETVAL = i_arc_out(im, x, y, rad, d1, d2, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_arc_out_aa); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_arc_out_aa)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "im, x, y, rad, d1, d2, val");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	i_img_dim	rad = (i_img_dim)SvIV(ST(3));
	double	d1 = (double)SvNV(ST(4));
	double	d2 = (double)SvNV(ST(5));
	Imager__Color	val;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(6)) && sv_derived_from(ST(6), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(6)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_arc_out_aa",
			"val", "Imager::Color");

	RETVAL = i_arc_out_aa(im, x, y, rad, d1, d2, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_bezier_multi); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_bezier_multi)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, xc, yc, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
	Imager__Color	val;
#line 1658 "Imager.xs"
	     double   *x,*y;
	     int       len;
	     AV       *av1;
	     AV       *av2;
	     SV       *sv1;
	     SV       *sv2;
	     int i;
#line 3996 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_bezier_multi",
			"val", "Imager::Color");
#line 1666 "Imager.xs"
	     ICL_info(val);
	     if (!SvROK(ST(1))) croak("Imager: Parameter 1 to i_bezier_multi must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(1))) != SVt_PVAV) croak("Imager: Parameter 1 to i_bezier_multi must be a reference to an array\n");
	     if (!SvROK(ST(2))) croak("Imager: Parameter 2 to i_bezier_multi must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(2))) != SVt_PVAV) croak("Imager: Parameter 2 to i_bezier_multi must be a reference to an array\n");
	     av1=(AV*)SvRV(ST(1));
	     av2=(AV*)SvRV(ST(2));
	     if (av_len(av1) != av_len(av2)) croak("Imager: x and y arrays to i_bezier_multi must be equal length\n");
	     len=av_len(av1)+1;
	     x=mymalloc( len*sizeof(double) );
	     y=mymalloc( len*sizeof(double) );
	     for(i=0;i<len;i++) {
	       sv1=(*(av_fetch(av1,i,0)));
	       sv2=(*(av_fetch(av2,i,0)));
	       x[i]=(double)SvNV(sv1);
	       y[i]=(double)SvNV(sv2);
	     }
             i_bezier_multi(im,len,x,y,val);
             myfree(x);
             myfree(y);
#line 4045 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_poly_aa); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_poly_aa)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, xc, yc, val");
    {
	Imager__ImgRaw	im;
	Imager__Color	val;
#line 1693 "Imager.xs"
	     double   *x,*y;
	     int       len;
	     AV       *av1;
	     AV       *av2;
	     SV       *sv1;
	     SV       *sv2;
	     int i;
#line 4073 "Imager.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    val = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_poly_aa",
			"val", "Imager::Color");
#line 1701 "Imager.xs"
	     ICL_info(val);
	     if (!SvROK(ST(1))) croak("Imager: Parameter 1 to i_poly_aa must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(1))) != SVt_PVAV) croak("Imager: Parameter 1 to i_poly_aa must be a reference to an array\n");
	     if (!SvROK(ST(2))) croak("Imager: Parameter 1 to i_poly_aa must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(2))) != SVt_PVAV) croak("Imager: Parameter 1 to i_poly_aa must be a reference to an array\n");
	     av1=(AV*)SvRV(ST(1));
	     av2=(AV*)SvRV(ST(2));
	     if (av_len(av1) != av_len(av2)) croak("Imager: x and y arrays to i_poly_aa must be equal length\n");
	     len=av_len(av1)+1;
	     x=mymalloc( len*sizeof(double) );
	     y=mymalloc( len*sizeof(double) );
	     for(i=0;i<len;i++) {
	       sv1=(*(av_fetch(av1,i,0)));
	       sv2=(*(av_fetch(av2,i,0)));
	       x[i]=(double)SvNV(sv1);
	       y[i]=(double)SvNV(sv2);
	     }
             RETVAL = i_poly_aa(im,len,x,y,val);
             myfree(x);
             myfree(y);
#line 4124 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_poly_aa_cfill); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_poly_aa_cfill)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, xc, yc, fill");
    {
	Imager__ImgRaw	im;
	Imager__FillHandle	fill;
#line 1729 "Imager.xs"
	     double   *x,*y;
	     int       len;
	     AV       *av1;
	     AV       *av2;
	     SV       *sv1;
	     SV       *sv2;
	     int i;
#line 4152 "Imager.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Imager::FillHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    fill = INT2PTR(Imager__FillHandle,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_poly_aa_cfill",
			"fill", "Imager::FillHandle");
#line 1737 "Imager.xs"
	     if (!SvROK(ST(1))) croak("Imager: Parameter 1 to i_poly_aa_cfill must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(1))) != SVt_PVAV) croak("Imager: Parameter 1 to i_poly_aa_cfill must be a reference to an array\n");
	     if (!SvROK(ST(2))) croak("Imager: Parameter 1 to i_poly_aa_cfill must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(2))) != SVt_PVAV) croak("Imager: Parameter 1 to i_poly_aa_cfill must be a reference to an array\n");
	     av1=(AV*)SvRV(ST(1));
	     av2=(AV*)SvRV(ST(2));
	     if (av_len(av1) != av_len(av2)) croak("Imager: x and y arrays to i_poly_aa_cfill must be equal length\n");
	     len=av_len(av1)+1;
	     x=mymalloc( len*sizeof(double) );
	     y=mymalloc( len*sizeof(double) );
	     for(i=0;i<len;i++) {
	       sv1=(*(av_fetch(av1,i,0)));
	       sv2=(*(av_fetch(av2,i,0)));
	       x[i]=(double)SvNV(sv1);
	       y[i]=(double)SvNV(sv2);
	     }
             RETVAL = i_poly_aa_cfill(im,len,x,y,fill);
             myfree(x);
             myfree(y);
#line 4202 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_flood_fill); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_flood_fill)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, seedx, seedy, dcol");
    {
	Imager__ImgRaw	im;
	i_img_dim	seedx = (i_img_dim)SvIV(ST(1));
	i_img_dim	seedy = (i_img_dim)SvIV(ST(2));
	Imager__Color	dcol;
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    dcol = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_flood_fill",
			"dcol", "Imager::Color");

	RETVAL = i_flood_fill(im, seedx, seedy, dcol);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_flood_cfill); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_flood_cfill)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, seedx, seedy, fill");
    {
	Imager__ImgRaw	im;
	i_img_dim	seedx = (i_img_dim)SvIV(ST(1));
	i_img_dim	seedy = (i_img_dim)SvIV(ST(2));
	Imager__FillHandle	fill;
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Imager::FillHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    fill = INT2PTR(Imager__FillHandle,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_flood_cfill",
			"fill", "Imager::FillHandle");

	RETVAL = i_flood_cfill(im, seedx, seedy, fill);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_flood_fill_border); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_flood_fill_border)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, seedx, seedy, dcol, border");
    {
	Imager__ImgRaw	im;
	i_img_dim	seedx = (i_img_dim)SvIV(ST(1));
	i_img_dim	seedy = (i_img_dim)SvIV(ST(2));
	Imager__Color	dcol;
	Imager__Color	border;
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    dcol = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_flood_fill_border",
			"dcol", "Imager::Color");

	if (SvROK(ST(4)) && sv_derived_from(ST(4), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(4)));
	    border = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_flood_fill_border",
			"border", "Imager::Color");

	RETVAL = i_flood_fill_border(im, seedx, seedy, dcol, border);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_flood_cfill_border); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_flood_cfill_border)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, seedx, seedy, fill, border");
    {
	Imager__ImgRaw	im;
	i_img_dim	seedx = (i_img_dim)SvIV(ST(1));
	i_img_dim	seedy = (i_img_dim)SvIV(ST(2));
	Imager__FillHandle	fill;
	Imager__Color	border;
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Imager::FillHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    fill = INT2PTR(Imager__FillHandle,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_flood_cfill_border",
			"fill", "Imager::FillHandle");

	if (SvROK(ST(4)) && sv_derived_from(ST(4), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(4)));
	    border = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_flood_cfill_border",
			"border", "Imager::Color");

	RETVAL = i_flood_cfill_border(im, seedx, seedy, fill, border);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_copyto); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_copyto)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 8)
       croak_xs_usage(cv,  "im, src, x1, y1, x2, y2, tx, ty");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	src;
	i_img_dim	x1 = (i_img_dim)SvIV(ST(2));
	i_img_dim	y1 = (i_img_dim)SvIV(ST(3));
	i_img_dim	x2 = (i_img_dim)SvIV(ST(4));
	i_img_dim	y2 = (i_img_dim)SvIV(ST(5));
	i_img_dim	tx = (i_img_dim)SvIV(ST(6));
	i_img_dim	ty = (i_img_dim)SvIV(ST(7));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            src = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                src = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");

	i_copyto(im, src, x1, y1, x2, y2, tx, ty);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_copyto_trans); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_copyto_trans)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 9)
       croak_xs_usage(cv,  "im, src, x1, y1, x2, y2, tx, ty, trans");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	src;
	i_img_dim	x1 = (i_img_dim)SvIV(ST(2));
	i_img_dim	y1 = (i_img_dim)SvIV(ST(3));
	i_img_dim	x2 = (i_img_dim)SvIV(ST(4));
	i_img_dim	y2 = (i_img_dim)SvIV(ST(5));
	i_img_dim	tx = (i_img_dim)SvIV(ST(6));
	i_img_dim	ty = (i_img_dim)SvIV(ST(7));
	Imager__Color	trans;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            src = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                src = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");

	if (SvROK(ST(8)) && sv_derived_from(ST(8), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(8)));
	    trans = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_copyto_trans",
			"trans", "Imager::Color");

	i_copyto_trans(im, src, x1, y1, x2, y2, tx, ty, trans);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_copy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_copy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "src");
    {
	Imager__ImgRaw	src;
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            src = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                src = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");

	RETVAL = i_copy(src);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_rubthru); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_rubthru)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 8)
       croak_xs_usage(cv,  "im, src, tx, ty, src_minx, src_miny, src_maxx, src_maxy");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	src;
	i_img_dim	tx = (i_img_dim)SvIV(ST(2));
	i_img_dim	ty = (i_img_dim)SvIV(ST(3));
	i_img_dim	src_minx = (i_img_dim)SvIV(ST(4));
	i_img_dim	src_miny = (i_img_dim)SvIV(ST(5));
	i_img_dim	src_maxx = (i_img_dim)SvIV(ST(6));
	i_img_dim	src_maxy = (i_img_dim)SvIV(ST(7));
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            src = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                src = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");

	RETVAL = i_rubthru(im, src, tx, ty, src_minx, src_miny, src_maxx, src_maxy);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_compose); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_compose)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 8 || items > 10)
       croak_xs_usage(cv,  "out, src, out_left, out_top, src_left, src_top, width, height, combine = ic_normal, opacity = 0.0");
    {
	Imager__ImgRaw	out;
	Imager__ImgRaw	src;
	i_img_dim	out_left = (i_img_dim)SvIV(ST(2));
	i_img_dim	out_top = (i_img_dim)SvIV(ST(3));
	i_img_dim	src_left = (i_img_dim)SvIV(ST(4));
	i_img_dim	src_top = (i_img_dim)SvIV(ST(5));
	i_img_dim	width = (i_img_dim)SvIV(ST(6));
	i_img_dim	height = (i_img_dim)SvIV(ST(7));
	int	combine;
	double	opacity;
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            out = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                out = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "out is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "out is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            src = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                src = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");

	if (items < 9)
	    combine = ic_normal;
	else {
	    combine = (int)SvIV(ST(8));
	}

	if (items < 10)
	    opacity = 0.0;
	else {
	    opacity = (double)SvNV(ST(9));
	}

	RETVAL = i_compose(out, src, out_left, out_top, src_left, src_top, width, height, combine, opacity);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_compose_mask); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_compose_mask)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 11 || items > 13)
       croak_xs_usage(cv,  "out, src, mask, out_left, out_top, src_left, src_top, mask_left, mask_top, width, height, combine = ic_normal, opacity = 0.0");
    {
	Imager__ImgRaw	out;
	Imager__ImgRaw	src;
	Imager__ImgRaw	mask;
	i_img_dim	out_left = (i_img_dim)SvIV(ST(3));
	i_img_dim	out_top = (i_img_dim)SvIV(ST(4));
	i_img_dim	src_left = (i_img_dim)SvIV(ST(5));
	i_img_dim	src_top = (i_img_dim)SvIV(ST(6));
	i_img_dim	mask_left = (i_img_dim)SvIV(ST(7));
	i_img_dim	mask_top = (i_img_dim)SvIV(ST(8));
	i_img_dim	width = (i_img_dim)SvIV(ST(9));
	i_img_dim	height = (i_img_dim)SvIV(ST(10));
	int	combine;
	double	opacity;
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            out = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                out = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "out is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "out is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            src = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                src = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(2), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(2)));
            mask = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(2), "Imager") && 
                 SvTYPE(SvRV(ST(2))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(2));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                mask = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "mask is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "mask is not of type Imager::ImgRaw");

	if (items < 12)
	    combine = ic_normal;
	else {
	    combine = (int)SvIV(ST(11));
	}

	if (items < 13)
	    opacity = 0.0;
	else {
	    opacity = (double)SvNV(ST(12));
	}

	RETVAL = i_compose_mask(out, src, mask, out_left, out_top, src_left, src_top, mask_left, mask_top, width, height, combine, opacity);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_combine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_combine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "src_av, channels_av = NULL");
    {
	AV *	src_av;
	AV *	channels_av;
#line 1866 "Imager.xs"
	i_img **imgs = NULL;
	STRLEN in_count;
	int *channels = NULL;
	int i;
	SV **psv;
	IV tmp;
#line 4883 "Imager.c"
	Imager__ImgRaw	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    src_av = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Imager::i_combine",
				"src_av");
		}
	} STMT_END;

	if (items < 2)
	    channels_av = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(1);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
			channels_av = (AV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				    "Imager::i_combine",
				    "channels_av");
		    }
	    } STMT_END;
	}
#line 1873 "Imager.xs"
	in_count = av_len(src_av) + 1;
	if (in_count > 0) {
	  imgs = mymalloc(sizeof(i_img*) * in_count);
	  channels = mymalloc(sizeof(int) * in_count);
	  for (i = 0; i < in_count; ++i) {
	    psv = av_fetch(src_av, i, 0);
	    if (!psv || !*psv || !sv_derived_from(*psv, "Imager::ImgRaw")) {
	      myfree(imgs);
	      myfree(channels);
	      croak("imgs must contain only images");
	    }
	    tmp = SvIV((SV*)SvRV(*psv));
	    imgs[i] = INT2PTR(i_img*, tmp);
	    if (channels_av &&
	        (psv = av_fetch(channels_av, i, 0)) != NULL &&
		*psv) {
	      channels[i] = SvIV(*psv);
	    }
	    else {
	      channels[i] = 0;
	    }
	  }
	}
	RETVAL = i_combine(imgs, channels, in_count);
	myfree(imgs);
	myfree(channels);
#line 4942 "Imager.c"
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_flipxy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_flipxy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, direction");
    {
	Imager__ImgRaw	im;
	int	direction = (int)SvIV(ST(1));
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_flipxy(im, direction);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_rotate90); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_rotate90)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, degrees");
    {
	Imager__ImgRaw	im;
	int	degrees = (int)SvIV(ST(1));
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_rotate90(im, degrees);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_rotate_exact); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_rotate_exact)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "im, amount, ...");
    {
	Imager__ImgRaw	im;
	double	amount = (double)SvNV(ST(1));
#line 1917 "Imager.xs"
	i_color *backp = NULL;
	i_fcolor *fbackp = NULL;
	int i;
	SV * sv1;
#line 5053 "Imager.c"
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 1922 "Imager.xs"
	/* extract the bg colors if any */
	/* yes, this is kind of strange */
	for (i = 2; i < items; ++i) {
          sv1 = ST(i);
          if (sv_derived_from(sv1, "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(sv1));
	    backp = INT2PTR(i_color *, tmp);
	  }
	  else if (sv_derived_from(sv1, "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(sv1));
	    fbackp = INT2PTR(i_fcolor *, tmp);
	  }
	}
	RETVAL = i_rotate_exact_bg(im, amount, backp, fbackp);
#line 5088 "Imager.c"
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_matrix_transform); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_matrix_transform)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4)
       croak_xs_usage(cv,  "im, xsize, ysize, matrix, ...");
    {
	Imager__ImgRaw	im;
	i_img_dim	xsize = (i_img_dim)SvIV(ST(1));
	i_img_dim	ysize = (i_img_dim)SvIV(ST(2));
#line 1945 "Imager.xs"
        double matrix[9];
        AV *av;
        IV len;
        SV *sv1;
        int i;
	i_color *backp = NULL;
	i_fcolor *fbackp = NULL;
#line 5119 "Imager.c"
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 1953 "Imager.xs"
        if (!SvROK(ST(3)) || SvTYPE(SvRV(ST(3))) != SVt_PVAV)
          croak("i_matrix_transform: parameter 4 must be an array ref\n");
	av=(AV*)SvRV(ST(3));
	len=av_len(av)+1;
        if (len > 9)
          len = 9;
        for (i = 0; i < len; ++i) {
	  sv1=(*(av_fetch(av,i,0)));
	  matrix[i] = SvNV(sv1);
        }
        for (; i < 9; ++i)
          matrix[i] = 0;
	/* extract the bg colors if any */
	/* yes, this is kind of strange */
	for (i = 4; i < items; ++i) {
          sv1 = ST(i);
          if (sv_derived_from(sv1, "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(sv1));
	    backp = INT2PTR(i_color *, tmp);
	  }
	  else if (sv_derived_from(sv1, "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(sv1));
	    fbackp = INT2PTR(i_fcolor *, tmp);
	  }
	}
        RETVAL = i_matrix_transform_bg(im, xsize, ysize, matrix, backp, fbackp);
#line 5166 "Imager.c"
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_gaussian); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_gaussian)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, stdev");
    {
	Imager__ImgRaw	im;
	double	stdev = (double)SvNV(ST(1));
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_gaussian(im, stdev);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_unsharp_mask); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_unsharp_mask)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "im, stdev, scale");
    {
	Imager__ImgRaw	im;
	double	stdev = (double)SvNV(ST(1));
	double	scale = (double)SvNV(ST(2));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_unsharp_mask(im, stdev, scale);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_conv); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_conv)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, coef");
    {
	Imager__ImgRaw	im;
	AV *	coef;
#line 1998 "Imager.xs"
	double*    c_coef;
	int     len;
	SV* sv1;
	int i;
#line 5274 "Imager.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    coef = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Imager::i_conv",
				"coef");
		}
	} STMT_END;
#line 2003 "Imager.xs"
	len = av_len(coef) + 1;
	c_coef=mymalloc( len * sizeof(double) );
	for(i = 0; i  < len; i++) {
	  sv1 = (*(av_fetch(coef, i, 0)));
	  c_coef[i] = (double)SvNV(sv1);
	}
	RETVAL = i_conv(im, c_coef, len);
	myfree(c_coef);
#line 5317 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_convert); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_convert)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "src, avmain");
    {
	Imager__ImgRaw	src;
	AV *	avmain;
#line 2019 "Imager.xs"
    	  double *coeff;
	  int outchan;
	  int inchan;
          SV **temp;
          AV *avsub;
	  int len;
	  int i, j;
#line 5345 "Imager.c"
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            src = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                src = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    avmain = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Imager::i_convert",
				"avmain");
		}
	} STMT_END;
#line 2027 "Imager.xs"
	  outchan = av_len(avmain)+1;
          /* find the biggest */
          inchan = 0;
	  for (j=0; j < outchan; ++j) {
	    temp = av_fetch(avmain, j, 0);
	    if (temp && SvROK(*temp) && SvTYPE(SvRV(*temp)) == SVt_PVAV) {
	      avsub = (AV*)SvRV(*temp);
	      len = av_len(avsub)+1;
	      if (len > inchan)
		inchan = len;
	    }
          }
          coeff = mymalloc(sizeof(double) * outchan * inchan);
	  for (j = 0; j < outchan; ++j) {
	    avsub = (AV*)SvRV(*av_fetch(avmain, j, 0));
	    len = av_len(avsub)+1;
	    for (i = 0; i < len; ++i) {
	      temp = av_fetch(avsub, i, 0);
	      if (temp)
		coeff[i+j*inchan] = SvNV(*temp);
	      else
	 	coeff[i+j*inchan] = 0;
	    }
	    while (i < inchan)
	      coeff[i++ + j*inchan] = 0;
	  }
	  RETVAL = i_convert(src, coeff, outchan, inchan);
          myfree(coeff);
#line 5407 "Imager.c"
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_map); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_map)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, pmaps");
    {
	Imager__ImgRaw	im;
#line 2063 "Imager.xs"
	  unsigned int mask = 0;
	  AV *avmain;
	  AV *avsub;
          SV **temp;
	  int len;
	  int i, j;
	  unsigned char (*maps)[256];
#line 5436 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 2071 "Imager.xs"
	  if (!SvROK(ST(1)) || SvTYPE(SvRV(ST(1))) != SVt_PVAV)
	    croak("i_map: parameter 2 must be an arrayref\n");
          avmain = (AV*)SvRV(ST(1));
	  len = av_len(avmain)+1;
	  if (im->channels < len) len = im->channels;

	  maps = mymalloc( len * sizeof(unsigned char [256]) );

	  for (j=0; j<len ; j++) {
	    temp = av_fetch(avmain, j, 0);
	    if (temp && SvROK(*temp) && (SvTYPE(SvRV(*temp)) == SVt_PVAV) ) {
	      avsub = (AV*)SvRV(*temp);
	      if(av_len(avsub) != 255) continue;
	      mask |= 1<<j;
              for (i=0; i<256 ; i++) {
		int val;
		temp = av_fetch(avsub, i, 0);
		val = temp ? SvIV(*temp) : 0;
		if (val<0) val = 0;
		if (val>255) val = 255;
		maps[j][i] = val;
	      }
            }
          }
          i_map(im, maps, mask);
	  myfree(maps);
#line 5482 "Imager.c"
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_diff); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_diff)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im1, im2");
    {
	Imager__ImgRaw	im1;
	Imager__ImgRaw	im2;
	float	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im1 = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im1 = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im1 is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im1 is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            im2 = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im2 = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im2 is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im2 is not of type Imager::ImgRaw");

	RETVAL = i_img_diff(im1, im2);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_diffd); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_diffd)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im1, im2");
    {
	Imager__ImgRaw	im1;
	Imager__ImgRaw	im2;
	double	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im1 = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im1 = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im1 is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im1 is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            im2 = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im2 = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im2 is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im2 is not of type Imager::ImgRaw");

	RETVAL = i_img_diffd(im1, im2);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_samef); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_samef)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "im1, im2, epsilon = i_img_epsilonf(), what=NULL");
    {
	Imager__ImgRaw	im1;
	Imager__ImgRaw	im2;
	double	epsilon;
	const char *	what;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im1 = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im1 = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im1 is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im1 is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            im2 = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im2 = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im2 is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im2 is not of type Imager::ImgRaw");

	if (items < 3)
	    epsilon = i_img_epsilonf();
	else {
	    epsilon = (double)SvNV(ST(2));
	}

	if (items < 4)
	    what = NULL;
	else {
	    what = (const char *)SvPV_nolen(ST(3));
	}

	RETVAL = i_img_samef(im1, im2, epsilon, what);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_epsilonf); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_epsilonf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	double	RETVAL;
	dXSTARG;

	RETVAL = i_img_epsilonf();
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__is_color_object); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__is_color_object)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0);
	bool	RETVAL;
#line 2124 "Imager.xs"
        SvGETMAGIC(sv);
        RETVAL = SvOK(sv) && SvROK(sv) &&
	   (sv_derived_from(sv, "Imager::Color")
          || sv_derived_from(sv, "Imager::Color::Float"));
#line 5718 "Imager.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef HAVE_LIBTT
#define XSubPPtmpAAAA 1


XS(XS_Imager_i_tt_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tt_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fontname");
    {
	char*	fontname = (char *)SvPV_nolen(ST(0));
	Imager__Font__TT	RETVAL;

	RETVAL = i_tt_new(fontname);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Font::TT", (void*)RETVAL);
    }
    XSRETURN(1);
}

#define TT_DESTROY(handle) i_tt_destroy(handle)

XS(XS_Imager__Font__TT_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Font__TT_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	Imager__Font__TT	handle;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(Imager__Font__TT,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Imager::Font::TT::DESTROY",
			"handle");

	TT_DESTROY(handle);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager__Font__TT_CLONE_SKIP); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Font__TT_CLONE_SKIP)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 2150 "Imager.xs"
        (void)items; /* avoid unused warning */
        RETVAL = 1;
#line 5795 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_tt_text); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tt_text)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 10 || items > 11)
       croak_xs_usage(cv,  "handle, im, xb, yb, cl, points, str_sv, len_ignored, smooth, utf8, align=1");
    {
	Imager__Font__TT	handle;
	Imager__ImgRaw	im;
	i_img_dim	xb = (i_img_dim)SvIV(ST(2));
	i_img_dim	yb = (i_img_dim)SvIV(ST(3));
	Imager__Color	cl;
	double	points = (double)SvNV(ST(5));
	SV *	str_sv = ST(6);
	int	smooth = (int)SvIV(ST(8));
	int	utf8 = (int)SvIV(ST(9));
	int	align;
#line 2172 "Imager.xs"
               char *str;
               STRLEN len;
#line 5826 "Imager.c"
	undef_int	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Font::TT")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(Imager__Font__TT,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_tt_text",
			"handle", "Imager::Font::TT");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(4)) && sv_derived_from(ST(4), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(4)));
	    cl = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_tt_text",
			"cl", "Imager::Color");

	if (items < 11)
	    align = 1;
	else {
	    align = (int)SvIV(ST(10));
	}
#line 2175 "Imager.xs"
#ifdef SvUTF8
               if (SvUTF8(str_sv))
                 utf8 = 1;
#endif
               str = SvPV(str_sv, len);
               RETVAL = i_tt_text(handle, im, xb, yb, cl, points, str, 
                                  len, smooth, utf8, align);
#line 5878 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_tt_cp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tt_cp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 10 || items > 11)
       croak_xs_usage(cv,  "handle, im, xb, yb, channel, points, str_sv, len_ignored, smooth, utf8, align=1");
    {
	Imager__Font__TT	handle;
	Imager__ImgRaw	im;
	i_img_dim	xb = (i_img_dim)SvIV(ST(2));
	i_img_dim	yb = (i_img_dim)SvIV(ST(3));
	int	channel = (int)SvIV(ST(4));
	double	points = (double)SvNV(ST(5));
	SV *	str_sv = ST(6);
	int	smooth = (int)SvIV(ST(8));
	int	utf8 = (int)SvIV(ST(9));
	int	align;
#line 2199 "Imager.xs"
               char *str;
               STRLEN len;
#line 5911 "Imager.c"
	undef_int	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Font::TT")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(Imager__Font__TT,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_tt_cp",
			"handle", "Imager::Font::TT");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (items < 11)
	    align = 1;
	else {
	    align = (int)SvIV(ST(10));
	}
#line 2202 "Imager.xs"
#ifdef SvUTF8
               if (SvUTF8(str_sv))
                 utf8 = 1;
#endif
               str = SvPV(str_sv, len);
               RETVAL = i_tt_cp(handle, im, xb, yb, channel, points, str, len,
                                smooth, utf8, align);
#line 5954 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_tt_bbox); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tt_bbox)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "handle, point, str_sv, len_ignored, utf8");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__Font__TT	handle;
	double	point = (double)SvNV(ST(1));
	SV*	str_sv = ST(2);
	int	utf8 = (int)SvIV(ST(4));
#line 2220 "Imager.xs"
	       i_img_dim cords[BOUNDING_BOX_COUNT];
	       int rc;
               char *  str;
               STRLEN len;
               int i;
#line 5986 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Font::TT")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(Imager__Font__TT,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_tt_bbox",
			"handle", "Imager::Font::TT");
#line 2226 "Imager.xs"
#ifdef SvUTF8
               if (SvUTF8(ST(2)))
                 utf8 = 1;
#endif
               str = SvPV(str_sv, len);
  	       if ((rc=i_tt_bbox(handle,point,str,len,cords, utf8))) {
                 EXTEND(SP, rc);
                 for (i = 0; i < rc; ++i) {
                   PUSHs(sv_2mortal(newSViv(cords[i])));
                 }
               }
#line 6008 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_tt_has_chars); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tt_has_chars)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, text_sv, utf8");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__Font__TT	handle;
	SV *	text_sv = ST(1);
	int	utf8 = (int)SvIV(ST(2));
#line 2244 "Imager.xs"
        char const *text;
        STRLEN len;
        char *work;
        size_t count;
        size_t i;
#line 6037 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Font::TT")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(Imager__Font__TT,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_tt_has_chars",
			"handle", "Imager::Font::TT");
#line 2250 "Imager.xs"
#ifdef SvUTF8
        if (SvUTF8(text_sv))
          utf8 = 1;
#endif
        text = SvPV(text_sv, len);
        work = mymalloc(len);
        count = i_tt_has_chars(handle, text, len, utf8, work);
        if (GIMME_V == G_ARRAY) {
          EXTEND(SP, count);
          for (i = 0; i < count; ++i) {
            PUSHs(boolSV(work[i]));
          }
        }
        else {
          EXTEND(SP, 1);
          PUSHs(sv_2mortal(newSVpv(work, count)));
        }
        myfree(work);
#line 6066 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_tt_dump_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tt_dump_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	Imager__Font__TT	handle;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Font::TT")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(Imager__Font__TT,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_tt_dump_names",
			"handle", "Imager::Font::TT");

	i_tt_dump_names(handle);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_tt_face_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tt_face_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__Font__TT	handle;
#line 2277 "Imager.xs"
        char name[255];
        size_t len;
#line 6118 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Font::TT")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(Imager__Font__TT,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_tt_face_name",
			"handle", "Imager::Font::TT");
#line 2280 "Imager.xs"
        len = i_tt_face_name(handle, name, sizeof(name));
        if (len) {
          EXTEND(SP, 1);
          PUSHs(sv_2mortal(newSVpv(name, len-1)));
        }
#line 6134 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_tt_glyph_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tt_glyph_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "handle, text_sv, utf8 = 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__Font__TT	handle;
	SV *	text_sv = ST(1);
	int	utf8;
#line 2292 "Imager.xs"
        char const *text;
        STRLEN work_len;
        size_t len;
        size_t outsize;
        char name[255];
#line 6163 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Font::TT")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(Imager__Font__TT,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_tt_glyph_name",
			"handle", "Imager::Font::TT");

	if (items < 3)
	    utf8 = 0;
	else {
	    utf8 = (int)SvIV(ST(2));
	}
#line 2298 "Imager.xs"
#ifdef SvUTF8
        if (SvUTF8(text_sv))
          utf8 = 1;
#endif
        text = SvPV(text_sv, work_len);
        len = work_len;
        while (len) {
          unsigned long ch;
          if (utf8) {
            ch = i_utf8_advance(&text, &len);
            if (ch == ~0UL) {
              i_push_error(0, "invalid UTF8 character");
              break;
            }
          }
          else {
            ch = *text++;
            --len;
          }
          EXTEND(SP, 1);
          if ((outsize = i_tt_glyph_name(handle, ch, name, sizeof(name))) != 0) {
            PUSHs(sv_2mortal(newSVpv(name, 0)));
          }
          else {
            PUSHs(&PL_sv_undef);
          } 
        }
#line 6207 "Imager.c"
	PUTBACK;
	return;
    }
}

#endif 

XS(XS_Imager_i_test_format_probe); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_test_format_probe)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ig, length");
    {
	Imager__IO	ig;
	int	length = (int)SvIV(ST(1));
	const char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_test_format_probe",
			"ig", "Imager::IO");

	RETVAL = i_test_format_probe(ig, length);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Imager_i_readpnm_wiol); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_readpnm_wiol)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ig, allow_incomplete");
    {
	Imager__IO	ig;
	int	allow_incomplete = (int)SvIV(ST(1));
	Imager__ImgRaw	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_readpnm_wiol",
			"ig", "Imager::IO");

	RETVAL = i_readpnm_wiol(ig, allow_incomplete);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_readpnm_multi_wiol); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_readpnm_multi_wiol)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ig, allow_incomplete");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__IO	ig;
	int	allow_incomplete = (int)SvIV(ST(1));
#line 2344 "Imager.xs"
        i_img **imgs;
        int count=0;
        int i;
#line 6299 "Imager.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_readpnm_multi_wiol",
			"ig", "Imager::IO");
#line 2348 "Imager.xs"
        imgs = i_readpnm_multi_wiol(ig, &count, allow_incomplete);
        if (imgs) {
          EXTEND(SP, count);
          for (i = 0; i < count; ++i) {
            SV *sv = sv_newmortal();
            sv_setref_pv(sv, "Imager::ImgRaw", (void *)imgs[i]);
            PUSHs(sv);
          }
          myfree(imgs);
        }
#line 6320 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_writeppm_wiol); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_writeppm_wiol)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, ig");
    {
	Imager__ImgRaw	im;
	Imager__IO	ig;
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_writeppm_wiol",
			"ig", "Imager::IO");

	RETVAL = i_writeppm_wiol(im, ig);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_readraw_wiol); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_readraw_wiol)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "ig, x, y, datachannels, storechannels, intrl");
    {
	Imager__IO	ig;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	int	datachannels = (int)SvIV(ST(3));
	int	storechannels = (int)SvIV(ST(4));
	int	intrl = (int)SvIV(ST(5));
	Imager__ImgRaw	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_readraw_wiol",
			"ig", "Imager::IO");

	RETVAL = i_readraw_wiol(ig, x, y, datachannels, storechannels, intrl);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_writeraw_wiol); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_writeraw_wiol)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, ig");
    {
	Imager__ImgRaw	im;
	Imager__IO	ig;
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_writeraw_wiol",
			"ig", "Imager::IO");

	RETVAL = i_writeraw_wiol(im, ig);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_writebmp_wiol); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_writebmp_wiol)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, ig");
    {
	Imager__ImgRaw	im;
	Imager__IO	ig;
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_writebmp_wiol",
			"ig", "Imager::IO");

	RETVAL = i_writebmp_wiol(im, ig);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_readbmp_wiol); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_readbmp_wiol)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "ig, allow_incomplete=0");
    {
	Imager__IO	ig;
	int	allow_incomplete;
	Imager__ImgRaw	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_readbmp_wiol",
			"ig", "Imager::IO");

	if (items < 2)
	    allow_incomplete = 0;
	else {
	    allow_incomplete = (int)SvIV(ST(1));
	}

	RETVAL = i_readbmp_wiol(ig, allow_incomplete);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_writetga_wiol); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_writetga_wiol)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, ig, wierdpack, compress, idstring");
    {
	Imager__ImgRaw	im;
	Imager__IO	ig;
	int	wierdpack = (int)SvIV(ST(2));
	int	compress = (int)SvIV(ST(3));
	char*	idstring = (char *)SvPV_nolen(ST(4));
#line 2401 "Imager.xs"
                int idlen;
#line 6574 "Imager.c"
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_writetga_wiol",
			"ig", "Imager::IO");
#line 2403 "Imager.xs"
                idlen  = SvCUR(ST(4));
                RETVAL = i_writetga_wiol(im, ig, wierdpack, compress, idstring, idlen);
#line 6606 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_readtga_wiol); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_readtga_wiol)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ig, length");
    {
	Imager__IO	ig;
	int	length = (int)SvIV(ST(1));
	Imager__ImgRaw	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::IO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ig = INT2PTR(Imager__IO,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_readtga_wiol",
			"ig", "Imager::IO");

	RETVAL = i_readtga_wiol(ig, length);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_scaleaxis); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_scaleaxis)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "im, Value, Axis");
    {
	Imager__ImgRaw	im;
	double	Value = (double)SvNV(ST(1));
	int	Axis = (int)SvIV(ST(2));
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_scaleaxis(im, Value, Axis);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_scale_nn); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_scale_nn)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "im, scx, scy");
    {
	Imager__ImgRaw	im;
	double	scx = (double)SvNV(ST(1));
	double	scy = (double)SvNV(ST(2));
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_scale_nn(im, scx, scy);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_scale_mixing); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_scale_mixing)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "im, width, height");
    {
	Imager__ImgRaw	im;
	i_img_dim	width = (i_img_dim)SvIV(ST(1));
	i_img_dim	height = (i_img_dim)SvIV(ST(2));
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_scale_mixing(im, width, height);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_haar); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_haar)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_haar(im);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_count_colors); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_count_colors)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, maxc");
    {
	Imager__ImgRaw	im;
	int	maxc = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_count_colors(im, maxc);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_get_anonymous_color_histo); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_get_anonymous_color_histo)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "im, maxc = 0x40000000");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
	int	maxc;
#line 2449 "Imager.xs"
        int i;
        unsigned int * col_usage = NULL;
        int col_cnt;
#line 6878 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (items < 2)
	    maxc = 0x40000000;
	else {
	    maxc = (int)SvIV(ST(1));
	}
#line 2453 "Imager.xs"
	col_cnt = i_get_anonymous_color_histo(im, &col_usage, maxc);
        EXTEND(SP, col_cnt);
        for (i = 0; i < col_cnt; i++)  {
            PUSHs(sv_2mortal(newSViv( col_usage[i])));
        }
        myfree(col_usage);
        XSRETURN(col_cnt);
#line 6911 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_transform); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_transform)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, opx, opy, parm");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
#line 2466 "Imager.xs"
             double* parm;
             int *opx;
             int *opy;
             int     opxl;
             int     opyl;
             int     parmlen;
             AV* av;
             SV* sv1;
             int i;
	     i_img *result;
#line 6943 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 2477 "Imager.xs"
             if (!SvROK(ST(1))) croak("Imager: Parameter 1 must be a reference to an array\n");
             if (!SvROK(ST(2))) croak("Imager: Parameter 2 must be a reference to an array\n");
             if (!SvROK(ST(3))) croak("Imager: Parameter 3 must be a reference to an array\n");
             if (SvTYPE(SvRV(ST(1))) != SVt_PVAV) croak("Imager: Parameter 1 must be a reference to an array\n");
             if (SvTYPE(SvRV(ST(2))) != SVt_PVAV) croak("Imager: Parameter 2 must be a reference to an array\n");
             if (SvTYPE(SvRV(ST(3))) != SVt_PVAV) croak("Imager: Parameter 3 must be a reference to an array\n");
             av=(AV*)SvRV(ST(1));
             opxl=av_len(av)+1;
             opx=mymalloc( opxl*sizeof(int) );
             for(i=0;i<opxl;i++) {
               sv1=(*(av_fetch(av,i,0)));
               opx[i]=(int)SvIV(sv1);
             }
             av=(AV*)SvRV(ST(2));
             opyl=av_len(av)+1;
             opy=mymalloc( opyl*sizeof(int) );
             for(i=0;i<opyl;i++) {
               sv1=(*(av_fetch(av,i,0)));
               opy[i]=(int)SvIV(sv1);
             }
             av=(AV*)SvRV(ST(3));
             parmlen=av_len(av)+1;
             parm=mymalloc( parmlen*sizeof(double) );
             for(i=0;i<parmlen;i++) { /* FIXME: Bug? */
               sv1=(*(av_fetch(av,i,0)));
               parm[i]=(double)SvNV(sv1);
             }
             result=i_transform(im,opx,opxl,opy,opyl,parm,parmlen);
             myfree(parm);
             myfree(opy);
             myfree(opx);
 	     if (result) {
	       SV *result_sv = sv_newmortal();
	       EXTEND(SP, 1);
	       sv_setref_pv(result_sv, "Imager::ImgRaw", (void*)result);
	       PUSHs(result_sv);
	     }
#line 7000 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_transform2); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_transform2)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "sv_width, sv_height, channels, sv_ops, av_n_regs, av_c_regs, av_in_imgs");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv_width = ST(0);
	SV *	sv_height = ST(1);
	SV *	sv_ops = ST(3);
	AV *	av_n_regs;
	AV *	av_c_regs;
	AV *	av_in_imgs;
	int	channels = (int)SvIV(ST(2));
#line 2525 "Imager.xs"
             i_img_dim width;
             i_img_dim height;
	     struct rm_op *ops;
	     STRLEN ops_len;
	     int ops_count;
             double *n_regs;
             int n_regs_count;
             i_color *c_regs;
	     int c_regs_count;
             int in_imgs_count;
             i_img **in_imgs;
             SV *sv1;
             IV tmp;
	     int i;
	     i_img *result;
#line 7043 "Imager.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(4);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    av_n_regs = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Imager::i_transform2",
				"av_n_regs");
		}
	} STMT_END;

	STMT_START {
		SV* const xsub_tmp_sv = ST(5);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    av_c_regs = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Imager::i_transform2",
				"av_c_regs");
		}
	} STMT_END;

	STMT_START {
		SV* const xsub_tmp_sv = ST(6);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    av_in_imgs = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Imager::i_transform2",
				"av_in_imgs");
		}
	} STMT_END;
#line 2542 "Imager.xs"
             in_imgs_count = av_len(av_in_imgs)+1;
	     for (i = 0; i < in_imgs_count; ++i) {
	       sv1 = *av_fetch(av_in_imgs, i, 0);
	       if (!sv_derived_from(sv1, "Imager::ImgRaw")) {
		 croak("sv_in_img must contain only images");
	       }
	     }
             if (in_imgs_count > 0) {
               in_imgs = mymalloc(in_imgs_count*sizeof(i_img*));
               for (i = 0; i < in_imgs_count; ++i) {              
	         sv1 = *av_fetch(av_in_imgs,i,0);
	         if (!sv_derived_from(sv1, "Imager::ImgRaw")) {
		   croak("Parameter 5 must contain only images");
	         }
                 tmp = SvIV((SV*)SvRV(sv1));
	         in_imgs[i] = INT2PTR(i_img*, tmp);
	       }
	     }
             else {
	       /* no input images */
	       in_imgs = NULL;
             }
             /* default the output size from the first input if possible */
             if (SvOK(sv_width))
	       width = SvIV(sv_width);
             else if (in_imgs_count)
	       width = in_imgs[0]->xsize;
             else
	       croak("No output image width supplied");

             if (SvOK(sv_height))
	       height = SvIV(sv_height);
             else if (in_imgs_count)
	       height = in_imgs[0]->ysize;
             else
	       croak("No output image height supplied");

	     ops = (struct rm_op *)SvPV(sv_ops, ops_len);
             if (ops_len % sizeof(struct rm_op))
	         croak("Imager: Parameter 3 must be a bitmap of regops\n");
	     ops_count = ops_len / sizeof(struct rm_op);

	     n_regs_count = av_len(av_n_regs)+1;
             n_regs = mymalloc(n_regs_count * sizeof(double));
	     for (i = 0; i < n_regs_count; ++i) {
	       sv1 = *av_fetch(av_n_regs,i,0);
	       if (SvOK(sv1))
	         n_regs[i] = SvNV(sv1);
	     }
             c_regs_count = av_len(av_c_regs)+1;
             c_regs = mymalloc(c_regs_count * sizeof(i_color));
             /* I don't bother initializing the colou?r registers */

	     result=i_transform2(width, height, channels, ops, ops_count, 
				 n_regs, n_regs_count, 
				 c_regs, c_regs_count, in_imgs, in_imgs_count);
	     if (in_imgs)
	         myfree(in_imgs);
             myfree(n_regs);
	     myfree(c_regs);
 	     if (result) {
	       SV *result_sv = sv_newmortal();
	       EXTEND(SP, 1);
	       sv_setref_pv(result_sv, "Imager::ImgRaw", (void*)result);
	       PUSHs(result_sv);
	     }
#line 7150 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_contrast); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_contrast)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, intensity");
    {
	Imager__ImgRaw	im;
	float	intensity = (float)SvNV(ST(1));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_contrast(im, intensity);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_hardinvert); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_hardinvert)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_hardinvert(im);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_hardinvertall); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_hardinvertall)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_hardinvertall(im);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_noise); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_noise)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "im, amount, type");
    {
	Imager__ImgRaw	im;
	float	amount = (float)SvNV(ST(1));
	unsigned char	type = (unsigned char)SvUV(ST(2));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_noise(im, amount, type);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_bumpmap); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_bumpmap)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "im, bump, channel, light_x, light_y, strength");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	bump;
	int	channel = (int)SvIV(ST(2));
	i_img_dim	light_x = (i_img_dim)SvIV(ST(3));
	i_img_dim	light_y = (i_img_dim)SvIV(ST(4));
	i_img_dim	strength = (i_img_dim)SvIV(ST(5));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            bump = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                bump = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "bump is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "bump is not of type Imager::ImgRaw");

	i_bumpmap(im, bump, channel, light_x, light_y, strength);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_bumpmap_complex); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_bumpmap_complex)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 14)
       croak_xs_usage(cv,  "im, bump, channel, tx, ty, Lx, Ly, Lz, cd, cs, n, Ia, Il, Is");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	bump;
	int	channel = (int)SvIV(ST(2));
	i_img_dim	tx = (i_img_dim)SvIV(ST(3));
	i_img_dim	ty = (i_img_dim)SvIV(ST(4));
	double	Lx = (double)SvNV(ST(5));
	double	Ly = (double)SvNV(ST(6));
	double	Lz = (double)SvNV(ST(7));
	float	cd = (float)SvNV(ST(8));
	float	cs = (float)SvNV(ST(9));
	float	n = (float)SvNV(ST(10));
	Imager__Color	Ia;
	Imager__Color	Il;
	Imager__Color	Is;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            bump = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                bump = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "bump is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "bump is not of type Imager::ImgRaw");

	if (SvROK(ST(11)) && sv_derived_from(ST(11), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(11)));
	    Ia = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_bumpmap_complex",
			"Ia", "Imager::Color");

	if (SvROK(ST(12)) && sv_derived_from(ST(12), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(12)));
	    Il = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_bumpmap_complex",
			"Il", "Imager::Color");

	if (SvROK(ST(13)) && sv_derived_from(ST(13), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(13)));
	    Is = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_bumpmap_complex",
			"Is", "Imager::Color");

	i_bumpmap_complex(im, bump, channel, tx, ty, Lx, Ly, Lz, cd, cs, n, Ia, Il, Is);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_postlevels); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_postlevels)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, levels");
    {
	Imager__ImgRaw	im;
	int	levels = (int)SvIV(ST(1));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_postlevels(im, levels);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_mosaic); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_mosaic)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, size");
    {
	Imager__ImgRaw	im;
	i_img_dim	size = (i_img_dim)SvIV(ST(1));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_mosaic(im, size);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_watermark); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_watermark)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, wmark, tx, ty, pixdiff");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	wmark;
	i_img_dim	tx = (i_img_dim)SvIV(ST(2));
	i_img_dim	ty = (i_img_dim)SvIV(ST(3));
	int	pixdiff = (int)SvIV(ST(4));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            wmark = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                wmark = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "wmark is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "wmark is not of type Imager::ImgRaw");

	i_watermark(im, wmark, tx, ty, pixdiff);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_autolevels); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_autolevels)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, lsat, usat, skew");
    {
	Imager__ImgRaw	im;
	float	lsat = (float)SvNV(ST(1));
	float	usat = (float)SvNV(ST(2));
	float	skew = (float)SvNV(ST(3));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_autolevels(im, lsat, usat, skew);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_radnoise); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_radnoise)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, xo, yo, rscale, ascale");
    {
	Imager__ImgRaw	im;
	float	xo = (float)SvNV(ST(1));
	float	yo = (float)SvNV(ST(2));
	float	rscale = (float)SvNV(ST(3));
	float	ascale = (float)SvNV(ST(4));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_radnoise(im, xo, yo, rscale, ascale);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_turbnoise); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_turbnoise)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, xo, yo, scale");
    {
	Imager__ImgRaw	im;
	float	xo = (float)SvNV(ST(1));
	float	yo = (float)SvNV(ST(2));
	float	scale = (float)SvNV(ST(3));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	i_turbnoise(im, xo, yo, scale);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_gradgen); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_gradgen)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "im, ...");
    {
	Imager__ImgRaw	im;
#line 2704 "Imager.xs"
	int num;
	i_img_dim *xo;
	i_img_dim *yo;
        i_color *ival;
	int dmeasure;
	int i;
	SV *sv;
	AV *axx;
	AV *ayy;
	AV *ac;
#line 7742 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 2715 "Imager.xs"
	if (items != 5)
	    croak("Usage: i_gradgen(im, xo, yo, ival, dmeasure)");
	if (!SvROK(ST(1)) || ! SvTYPE(SvRV(ST(1))))
	    croak("i_gradgen: Second argument must be an array ref");
	if (!SvROK(ST(2)) || ! SvTYPE(SvRV(ST(2))))
	    croak("i_gradgen: Third argument must be an array ref");
	if (!SvROK(ST(3)) || ! SvTYPE(SvRV(ST(3))))
	    croak("i_gradgen: Fourth argument must be an array ref");
	axx = (AV *)SvRV(ST(1));
	ayy = (AV *)SvRV(ST(2));
	ac  = (AV *)SvRV(ST(3));
	dmeasure = (int)SvIV(ST(4));

        num = av_len(axx) < av_len(ayy) ? av_len(axx) : av_len(ayy);
	num = num <= av_len(ac) ? num : av_len(ac);
	num++; 
	if (num < 2) croak("Usage: i_gradgen array refs must have more than 1 entry each");
	xo = mymalloc( sizeof(i_img_dim) * num );
	yo = mymalloc( sizeof(i_img_dim) * num );
	ival = mymalloc( sizeof(i_color) * num );
	for(i = 0; i<num; i++) {
	  xo[i]   = (i_img_dim)SvIV(* av_fetch(axx, i, 0));
	  yo[i]   = (i_img_dim)SvIV(* av_fetch(ayy, i, 0));
          sv = *av_fetch(ac, i, 0);
	  if ( !sv_derived_from(sv, "Imager::Color") ) {
	    free(axx); free(ayy); free(ac);
            croak("i_gradgen: Element of fourth argument is not derived from Imager::Color");
	  }
	  ival[i] = *INT2PTR(i_color *, SvIV((SV *)SvRV(sv)));
	}
        i_gradgen(im, num, xo, yo, ival, dmeasure);
        myfree(xo);
        myfree(yo);
        myfree(ival);
#line 7796 "Imager.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_diff_image); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_diff_image)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "im, im2, mindist=0");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	im2;
	double	mindist;
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            im2 = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(1), "Imager") && 
                 SvTYPE(SvRV(ST(1))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(1));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im2 = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im2 is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im2 is not of type Imager::ImgRaw");

	if (items < 3)
	    mindist = 0;
	else {
	    mindist = (double)SvNV(ST(2));
	}

	RETVAL = i_diff_image(im, im2, mindist);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_fountain); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_fountain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 11)
       croak_xs_usage(cv,  "im, xa, ya, xb, yb, type, repeat, combine, super_sample, ssample_param, segs");
    {
	Imager__ImgRaw	im;
	double	xa = (double)SvNV(ST(1));
	double	ya = (double)SvNV(ST(2));
	double	xb = (double)SvNV(ST(3));
	double	yb = (double)SvNV(ST(4));
	int	type = (int)SvIV(ST(5));
	int	repeat = (int)SvIV(ST(6));
	int	combine = (int)SvIV(ST(7));
	int	super_sample = (int)SvIV(ST(8));
	double	ssample_param = (double)SvNV(ST(9));
#line 2769 "Imager.xs"
        AV *asegs;
        int count;
        i_fountain_seg *segs;
#line 7894 "Imager.c"
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 2773 "Imager.xs"
	if (!SvROK(ST(10)) || ! SvTYPE(SvRV(ST(10))))
	    croak("i_fountain: argument 11 must be an array ref");

	asegs = (AV *)SvRV(ST(10));
        segs = load_fount_segs(aTHX_ asegs, &count);
        RETVAL = i_fountain(im, xa, ya, xb, yb, type, repeat, combine, 
                            super_sample, ssample_param, count, segs);
        myfree(segs);
#line 7923 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_new_fill_fount); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_new_fill_fount)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 10)
       croak_xs_usage(cv,  "xa, ya, xb, yb, type, repeat, combine, super_sample, ssample_param, segs");
    {
	double	xa = (double)SvNV(ST(0));
	double	ya = (double)SvNV(ST(1));
	double	xb = (double)SvNV(ST(2));
	double	yb = (double)SvNV(ST(3));
	int	type = (int)SvIV(ST(4));
	int	repeat = (int)SvIV(ST(5));
	int	combine = (int)SvIV(ST(6));
	int	super_sample = (int)SvIV(ST(7));
	double	ssample_param = (double)SvNV(ST(8));
#line 2796 "Imager.xs"
        AV *asegs;
        int count;
        i_fountain_seg *segs;
#line 7956 "Imager.c"
	Imager__FillHandle	RETVAL;
#line 2800 "Imager.xs"
	if (!SvROK(ST(9)) || ! SvTYPE(SvRV(ST(9))))
	    croak("i_fountain: argument 11 must be an array ref");

	asegs = (AV *)SvRV(ST(9));
        segs = load_fount_segs(aTHX_ asegs, &count);
        RETVAL = i_new_fill_fount(xa, ya, xb, yb, type, repeat, combine, 
                                  super_sample, ssample_param, count, segs);
        myfree(segs);        
#line 7967 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::FillHandle", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_new_fill_opacity); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_new_fill_opacity)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "other_fill, alpha_mult");
    {
	Imager__FillHandle	other_fill;
	double	alpha_mult = (double)SvNV(ST(1));
	Imager__FillHandle	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::FillHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    other_fill = INT2PTR(Imager__FillHandle,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_new_fill_opacity",
			"other_fill", "Imager::FillHandle");

	RETVAL = i_new_fill_opacity(other_fill, alpha_mult);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::FillHandle", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_errors); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_errors)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2819 "Imager.xs"
        i_errmsg *errors;
	int i;
	AV *av;
	SV *sv;
#line 8025 "Imager.c"
#line 2824 "Imager.xs"
	errors = i_errors();
	i = 0;
	while (errors[i].msg) {
	  av = newAV();
	  sv = newSVpv(errors[i].msg, strlen(errors[i].msg));
	  if (!av_store(av, 0, sv)) {
	    SvREFCNT_dec(sv);
	  }
	  sv = newSViv(errors[i].code);
	  if (!av_store(av, 1, sv)) {
	    SvREFCNT_dec(sv);
	  }
	  PUSHs(sv_2mortal(newRV_noinc((SV*)av)));
	  ++i;
	}
#line 8042 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_clear_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_clear_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	i_clear_error();
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_push_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_push_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "code, msg");
    {
	int	code = (int)SvIV(ST(0));
	const char *	msg = (const char *)SvPV_nolen(ST(1));

	i_push_error(code, msg);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_i_nearest_color); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_nearest_color)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "im, ...");
    {
	Imager__ImgRaw	im;
#line 2852 "Imager.xs"
	int num;
	i_img_dim *xo;
	i_img_dim *yo;
        i_color *ival;
	int dmeasure;
	int i;
	SV *sv;
	AV *axx;
	AV *ayy;
	AV *ac;
#line 8110 "Imager.c"
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 2863 "Imager.xs"
	if (items != 5)
	    croak("Usage: i_nearest_color(im, xo, yo, ival, dmeasure)");
	if (!SvROK(ST(1)) || ! SvTYPE(SvRV(ST(1))))
	    croak("i_nearest_color: Second argument must be an array ref");
	if (!SvROK(ST(2)) || ! SvTYPE(SvRV(ST(2))))
	    croak("i_nearest_color: Third argument must be an array ref");
	if (!SvROK(ST(3)) || ! SvTYPE(SvRV(ST(3))))
	    croak("i_nearest_color: Fourth argument must be an array ref");
	axx = (AV *)SvRV(ST(1));
	ayy = (AV *)SvRV(ST(2));
	ac  = (AV *)SvRV(ST(3));
	dmeasure = (int)SvIV(ST(4));

        num = av_len(axx) < av_len(ayy) ? av_len(axx) : av_len(ayy);
	num = num <= av_len(ac) ? num : av_len(ac);
	num++; 
	if (num < 2) croak("Usage: i_nearest_color array refs must have more than 1 entry each");
	xo = mymalloc( sizeof(i_img_dim) * num );
	yo = mymalloc( sizeof(i_img_dim) * num );
	ival = mymalloc( sizeof(i_color) * num );
	for(i = 0; i<num; i++) {
	  xo[i]   = (i_img_dim)SvIV(* av_fetch(axx, i, 0));
	  yo[i]   = (i_img_dim)SvIV(* av_fetch(ayy, i, 0));
          sv = *av_fetch(ac, i, 0);
	  if ( !sv_derived_from(sv, "Imager::Color") ) {
	    free(axx); free(ayy); free(ac);
            croak("i_nearest_color: Element of fourth argument is not derived from Imager::Color");
	  }
	  ival[i] = *INT2PTR(i_color *, SvIV((SV *)SvRV(sv)));
	}
        RETVAL = i_nearest_color(im, num, xo, yo, ival, dmeasure);
#line 8162 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_malloc_state); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_malloc_state)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	malloc_state();
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager_DSO_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_DSO_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	filename = (char *)SvPV_nolen(ST(0));
#line 2904 "Imager.xs"
	       void *rc;
	       char *evstr;
#line 8206 "Imager.c"
#line 2907 "Imager.xs"
	       rc=DSO_open(filename,&evstr);
               if (rc!=NULL) {
                 if (evstr!=NULL) {
                   EXTEND(SP,2); 
                   PUSHs(sv_2mortal(newSViv(PTR2IV(rc))));
                   PUSHs(sv_2mortal(newSVpvn(evstr, strlen(evstr))));
                 } else {
                   EXTEND(SP,1);
                   PUSHs(sv_2mortal(newSViv(PTR2IV(rc))));
                 }
               }
#line 8219 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_DSO_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_DSO_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dso_handle");
    {
	void*	dso_handle = INT2PTR(void *,SvIV(ST(0)));
	undef_int	RETVAL;

	RETVAL = DSO_close(dso_handle);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_DSO_funclist); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_DSO_funclist)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dso_handle_v");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void*	dso_handle_v = INT2PTR(void *,SvIV(ST(0)));
#line 2928 "Imager.xs"
	       int i;
	       DSO_handle *dso_handle;
	       func_ptr *functions;
#line 8267 "Imager.c"
#line 2932 "Imager.xs"
	       dso_handle=(DSO_handle*)dso_handle_v;
	       functions = DSO_funclist(dso_handle);
	       i=0;
	       while( functions[i].name != NULL) {
	         EXTEND(SP,1);
		 PUSHs(sv_2mortal(newSVpv(functions[i].name,0)));
	         EXTEND(SP,1);
		 PUSHs(sv_2mortal(newSVpv(functions[i++].pcode,0)));
	       }
#line 8278 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_DSO_call); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_DSO_call)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, func_index, hv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void*	handle = INT2PTR(void *,SvIV(ST(0)));
	int	func_index = (int)SvIV(ST(1));
#line 2947 "Imager.xs"
	       HV* hv;
#line 8302 "Imager.c"
#line 2949 "Imager.xs"
	       if (!SvROK(ST(2))) croak("Imager: Parameter 2 must be a reference to a hash\n");	       
	       hv=(HV*)SvRV(ST(2));
	       if (SvTYPE(hv)!=SVt_PVHV) croak("Imager: Parameter 2 must be a reference to a hash\n");
	       DSO_call( (DSO_handle *)handle,func_index,hv);
#line 8308 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_get_pixel); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_get_pixel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "im, x, y");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
#line 2960 "Imager.xs"
        i_color *color;
#line 8331 "Imager.c"
	SV *	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 2962 "Imager.xs"
	color = (i_color *)mymalloc(sizeof(i_color));
	if (i_gpix(im, x, y, color) == 0) {
          RETVAL = NEWSV(0, 0);
          sv_setref_pv(RETVAL, "Imager::Color", (void *)color);
        }
        else {
          myfree(color);
          RETVAL = &PL_sv_undef;
        }
#line 8361 "Imager.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager_i_ppix); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_ppix)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, x, y, cl");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	Imager__Color	cl;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    cl = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_ppix",
			"cl", "Imager::Color");

	RETVAL = i_ppix(im, x, y, cl);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_pal_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_pal_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "x, y, channels, maxpal");
    {
	i_img_dim	x = (i_img_dim)SvIV(ST(0));
	i_img_dim	y = (i_img_dim)SvIV(ST(1));
	int	channels = (int)SvIV(ST(2));
	int	maxpal = (int)SvIV(ST(3));
	Imager__ImgRaw	RETVAL;

	RETVAL = i_img_pal_new(x, y, channels, maxpal);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_to_pal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_to_pal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "src, quant");
    {
	Imager__ImgRaw	src;
#line 2993 "Imager.xs"
        HV *hv;
        i_quantize quant;
#line 8462 "Imager.c"
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            src = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                src = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
#line 2996 "Imager.xs"
        if (!SvROK(ST(1)) || ! SvTYPE(SvRV(ST(1))))
          croak("i_img_to_pal: second argument must be a hash ref");
        hv = (HV *)SvRV(ST(1));
        memset(&quant, 0, sizeof(quant));
	quant.version = 1;
        quant.mc_size = 256;
	ip_handle_quant_opts(aTHX_ &quant, hv);
        RETVAL = i_img_to_pal(src, &quant);
        if (RETVAL) {
          ip_copy_colors_back(aTHX_ hv, &quant);
        }
	ip_cleanup_quant_opts(aTHX_ &quant);
#line 8495 "Imager.c"
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_to_rgb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_to_rgb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "src");
    {
	Imager__ImgRaw	src;
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            src = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                src = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");

	RETVAL = i_img_to_rgb(src);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_make_palette); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_make_palette)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "quant_hv, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 3018 "Imager.xs"
        size_t count = items - 1;
	i_quantize quant;
	i_img **imgs = NULL;
	ssize_t i;
#line 8563 "Imager.c"
	HV *	quant_hv;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    quant_hv = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Imager::i_img_make_palette",
				"quant_hv");
		}
	} STMT_END;
#line 3023 "Imager.xs"
        if (count <= 0)
	  croak("Please supply at least one image (%d)", (int)count);
        imgs = mymalloc(sizeof(i_img *) * count);
	for (i = 0; i < count; ++i) {
	  SV *img_sv = ST(i + 1);
	  if (SvROK(img_sv) && sv_derived_from(img_sv, "Imager::ImgRaw")) {
	    imgs[i] = INT2PTR(i_img *, SvIV((SV*)SvRV(img_sv)));
	  }
	  else {
	    myfree(imgs);
	    croak("Image %d is not an image object", (int)i+1);
          }
	}
        memset(&quant, 0, sizeof(quant));
	quant.version = 1;
	quant.mc_size = 256;
        ip_handle_quant_opts(aTHX_ &quant, quant_hv);
	i_quant_makemap(&quant, imgs, count);
	EXTEND(SP, quant.mc_count);
	for (i = 0; i < quant.mc_count; ++i) {
	  SV *sv_c = make_i_color_sv(aTHX_ quant.mc_colors + i);
	  PUSHs(sv_c);
	}
 	ip_cleanup_quant_opts(aTHX_ &quant);
#line 8603 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_gpal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_gpal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, l, r, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	r = (i_img_dim)SvIV(ST(2));
	i_img_dim	y = (i_img_dim)SvIV(ST(3));
#line 3056 "Imager.xs"
        i_palidx *work;
        int count, i;
#line 8630 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3059 "Imager.xs"
        if (l < r) {
          work = mymalloc((r-l) * sizeof(i_palidx));
          count = i_gpal(im, l, r, y, work);
          if (GIMME_V == G_ARRAY) {
            EXTEND(SP, count);
            for (i = 0; i < count; ++i) {
              PUSHs(sv_2mortal(newSViv(work[i])));
            }
          }
          else {
            EXTEND(SP, 1);
            PUSHs(sv_2mortal(newSVpv((char *)work, count * sizeof(i_palidx))));
          }
          myfree(work);
        }
        else {
          if (GIMME_V != G_ARRAY) {
            EXTEND(SP, 1);
            PUSHs(&PL_sv_undef);
          }
        }
#line 8671 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_ppal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_ppal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3)
       croak_xs_usage(cv,  "im, l, y, ...");
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
#line 3087 "Imager.xs"
        i_palidx *work;
        i_img_dim i;
#line 8695 "Imager.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3090 "Imager.xs"
        if (items > 3) {
          work = malloc_temp(aTHX_ sizeof(i_palidx) * (items-3));
          for (i=0; i < items-3; ++i) {
            work[i] = SvIV(ST(i+3));
          }
          validate_i_ppal(im, work, items - 3);
          RETVAL = i_ppal(im, l, l+items-3, y, work);
        }
        else {
          RETVAL = 0;
        }
#line 8728 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_ppal_p); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_ppal_p)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, l, y, data");
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	SV *	data = ST(3);
#line 3111 "Imager.xs"
        i_palidx const *work;
        STRLEN len;
#line 8753 "Imager.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3114 "Imager.xs"
        work = (i_palidx const *)SvPV(data, len);
        len /= sizeof(i_palidx);
        if (len > 0) {
          validate_i_ppal(im, work, len);
          RETVAL = i_ppal(im, l, l+len, y, work);
        }
        else {
          RETVAL = 0;
        }
#line 8784 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_addcolors); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_addcolors)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "im, ...");
    {
	Imager__ImgRaw	im;
#line 3130 "Imager.xs"
        int index;
        i_color *colors;
        int i;
#line 8807 "Imager.c"
	SV *	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3134 "Imager.xs"
        if (items < 2)
          croak("i_addcolors: no colors to add");
        colors = mymalloc((items-1) * sizeof(i_color));
        for (i=0; i < items-1; ++i) {
          if (sv_isobject(ST(i+1)) 
              && sv_derived_from(ST(i+1), "Imager::Color")) {
            IV tmp = SvIV((SV *)SvRV(ST(i+1)));
            colors[i] = *INT2PTR(i_color *, tmp);
          }
          else {
            myfree(colors);
            croak("i_addcolor: pixels must be Imager::Color objects");
          }
        }
        index = i_addcolors(im, colors, items-1);
        myfree(colors);
        if (index == 0) {
          RETVAL = newSVpv("0 but true", 0);
        }
        else if (index == -1) {
          RETVAL = &PL_sv_undef;
        }
        else {
          RETVAL = newSViv(index);
        }
#line 8853 "Imager.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager_i_setcolors); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_setcolors)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "im, index, ...");
    {
	Imager__ImgRaw	im;
	int	index = (int)SvIV(ST(1));
#line 3167 "Imager.xs"
        i_color *colors;
        int i;
#line 8877 "Imager.c"
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3170 "Imager.xs"
        if (items < 3)
          croak("i_setcolors: no colors to add");
        colors = mymalloc((items-2) * sizeof(i_color));
        for (i=0; i < items-2; ++i) {
          if (sv_isobject(ST(i+2)) 
              && sv_derived_from(ST(i+2), "Imager::Color")) {
            IV tmp = SvIV((SV *)SvRV(ST(i+2)));
            colors[i] = *INT2PTR(i_color *, tmp);
          }
          else {
            myfree(colors);
            croak("i_setcolors: pixels must be Imager::Color objects");
          }
        }
        RETVAL = i_setcolors(im, index, colors, items-2);
        myfree(colors);
#line 8914 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_getcolors); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_getcolors)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "im, index, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
	int	index = (int)SvIV(ST(1));
#line 3194 "Imager.xs"
        i_color *colors;
        int count = 1;
        int i;
#line 8942 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3198 "Imager.xs"
        if (items > 3)
          croak("i_getcolors: too many arguments");
        if (items == 3)
          count = SvIV(ST(2));
        if (count < 1)
          croak("i_getcolors: count must be positive");
        colors = mymalloc(sizeof(i_color) * count);
        if (i_getcolors(im, index, colors, count)) {
          for (i = 0; i < count; ++i) {
            SV *sv = make_i_color_sv(aTHX_ colors+i);
            PUSHs(sv);
          }
        }
        myfree(colors);
#line 8976 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_colorcount); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_colorcount)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	undef_neg_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_colorcount(im);
	ST(0) = sv_newmortal();
	if (RETVAL < 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_maxcolors); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_maxcolors)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	undef_neg_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_maxcolors(im);
	ST(0) = sv_newmortal();
	if (RETVAL < 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_findcolor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_findcolor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, color");
    {
	Imager__ImgRaw	im;
	Imager__Color	color;
#line 3227 "Imager.xs"
        i_palidx index;
#line 9080 "Imager.c"
	SV *	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    color = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_findcolor",
			"color", "Imager::Color");
#line 3229 "Imager.xs"
        if (i_findcolor(im, color, &index)) {
          RETVAL = newSViv(index);
        }
        else {
          RETVAL = &PL_sv_undef;
        }
#line 9116 "Imager.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_bits); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_bits)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_img_bits(im);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_img_type(im);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_virtual); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_virtual)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_img_virtual(im);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_gsamp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_gsamp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, l, r, y, channels");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	r = (i_img_dim)SvIV(ST(2));
	i_img_dim	y = (i_img_dim)SvIV(ST(3));
	i_channel_list	channels;
#line 3258 "Imager.xs"
        i_sample_t *data;
        i_img_dim count, i;
#line 9265 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        SvGETMAGIC(ST(4));
	if (SvOK(ST(4))) {
	  AV *channels_av;
	  int i;
	  if (!SvROK(ST(4)) || SvTYPE(SvRV(ST(4))) != SVt_PVAV) {
	    croak("channels is not an array ref");
	  }
	  channels_av = (AV *)SvRV(ST(4));
 	  channels.count = av_len(channels_av) + 1;
	  if (channels.count < 1) {
	    croak("Imager::i_gsamp: no channels provided");
	  }
	  channels.channels = malloc_temp(aTHX_ sizeof(int) * channels.count);
 	  for (i = 0; i < channels.count; ++i) {
	    SV **entry = av_fetch(channels_av, i, 0);
	    channels.channels[i] = entry ? SvIV(*entry) : 0;
	  }
        }
	else {
	  /* assumes we have an image */
	  channels.count = im->channels;
	  channels.channels = NULL;
	};
#line 3261 "Imager.xs"
        if (l < r) {
          data = mymalloc(sizeof(i_sample_t) * (r-l) * channels.count); /* XXX: memleak? */
          count = i_gsamp(im, l, r, y, data, channels.channels, channels.count);
          if (GIMME_V == G_ARRAY) {
            EXTEND(SP, count);
            for (i = 0; i < count; ++i)
              PUSHs(sv_2mortal(newSViv(data[i])));
          }
          else {
            EXTEND(SP, 1);
            PUSHs(sv_2mortal(newSVpv((char *)data, count * sizeof(i_sample_t))));
          }
	  myfree(data);
        }
        else {
          if (GIMME_V != G_ARRAY) {
            EXTEND(SP, 1);
            PUSHs(&PL_sv_undef);
          }
        }
#line 9329 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_gsamp_bits); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_gsamp_bits)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 8)
       croak_xs_usage(cv,  "im, l, r, y, bits, target, offset, channels");
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	r = (i_img_dim)SvIV(ST(2));
	i_img_dim	y = (i_img_dim)SvIV(ST(3));
	int	bits = (int)SvIV(ST(4));
	AV *	target;
	STRLEN	offset = (STRLEN)SvUV(ST(6));
	i_channel_list	channels;
#line 3293 "Imager.xs"
        unsigned *data;
        i_img_dim count, i;
#line 9358 "Imager.c"
	undef_neg_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	STMT_START {
		SV* const xsub_tmp_sv = ST(5);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    target = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Imager::i_gsamp_bits",
				"target");
		}
	} STMT_END;

        SvGETMAGIC(ST(7));
	if (SvOK(ST(7))) {
	  AV *channels_av;
	  int i;
	  if (!SvROK(ST(7)) || SvTYPE(SvRV(ST(7))) != SVt_PVAV) {
	    croak("channels is not an array ref");
	  }
	  channels_av = (AV *)SvRV(ST(7));
 	  channels.count = av_len(channels_av) + 1;
	  if (channels.count < 1) {
	    croak("Imager::i_gsamp_bits: no channels provided");
	  }
	  channels.channels = malloc_temp(aTHX_ sizeof(int) * channels.count);
 	  for (i = 0; i < channels.count; ++i) {
	    SV **entry = av_fetch(channels_av, i, 0);
	    channels.channels[i] = entry ? SvIV(*entry) : 0;
	  }
        }
	else {
	  /* assumes we have an image */
	  channels.count = im->channels;
	  channels.channels = NULL;
	};
#line 3296 "Imager.xs"
	i_clear_error();
        if (items < 8)
          croak("No channel numbers supplied to g_samp()");
        if (l < r) {
          data = mymalloc(sizeof(unsigned) * (r-l) * channels.count);
          count = i_gsamp_bits(im, l, r, y, data, channels.channels, channels.count, bits);
	  for (i = 0; i < count; ++i) {
	    av_store(target, i+offset, newSVuv(data[i]));
	  }
	  myfree(data);
	  RETVAL = count;
        }
        else {
	  RETVAL = 0;
        }
#line 9431 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL < 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_psamp_bits); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_psamp_bits)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 6 || items > 8)
       croak_xs_usage(cv,  "im, l, y, bits, channels, data_av, data_offset = 0, pixel_count = -1");
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	int	bits = (int)SvIV(ST(3));
	i_channel_list	channels;
	AV *	data_av;
	i_img_dim	data_offset;
	i_img_dim	pixel_count;
#line 3325 "Imager.xs"
	STRLEN data_count;
	size_t data_used;
	unsigned *data;
	ptrdiff_t i;
#line 9464 "Imager.c"
	undef_neg_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        SvGETMAGIC(ST(4));
	if (SvOK(ST(4))) {
	  AV *channels_av;
	  int i;
	  if (!SvROK(ST(4)) || SvTYPE(SvRV(ST(4))) != SVt_PVAV) {
	    croak("channels is not an array ref");
	  }
	  channels_av = (AV *)SvRV(ST(4));
 	  channels.count = av_len(channels_av) + 1;
	  if (channels.count < 1) {
	    croak("Imager::i_psamp_bits: no channels provided");
	  }
	  channels.channels = malloc_temp(aTHX_ sizeof(int) * channels.count);
 	  for (i = 0; i < channels.count; ++i) {
	    SV **entry = av_fetch(channels_av, i, 0);
	    channels.channels[i] = entry ? SvIV(*entry) : 0;
	  }
        }
	else {
	  /* assumes we have an image */
	  channels.count = im->channels;
	  channels.channels = NULL;
	};

	STMT_START {
		SV* const xsub_tmp_sv = ST(5);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    data_av = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Imager::i_psamp_bits",
				"data_av");
		}
	} STMT_END;

	if (items < 7)
	    data_offset = 0;
	else {
	    data_offset = (i_img_dim)SvIV(ST(6));
	}

	if (items < 8)
	    pixel_count = -1;
	else {
	    pixel_count = (i_img_dim)SvIV(ST(7));
	}
#line 3330 "Imager.xs"
	i_clear_error();

	data_count = av_len(data_av) + 1;
	if (data_offset < 0) {
	  croak("data_offset must be non-negative");
	}
	if (data_offset > data_count) {
	  croak("data_offset greater than number of samples supplied");
        }
	if (pixel_count == -1 || 
	    data_offset + pixel_count * channels.count > data_count) {
	  pixel_count = (data_count - data_offset) / channels.count;
	}

	data_used = pixel_count * channels.count;
	data = mymalloc(sizeof(unsigned) * data_count);
	for (i = 0; i < data_used; ++i)
	  data[i] = SvUV(*av_fetch(data_av, data_offset + i, 0));

	RETVAL = i_psamp_bits(im, l, l + pixel_count, y, data, channels.channels, 
	                      channels.count, bits);

	if (data)
	  myfree(data);
#line 9558 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL < 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_psamp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_psamp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 5 || items > 7)
       croak_xs_usage(cv,  "im, x, y, channels, data, offset = 0, width = -1");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	i_channel_list	channels;
	i_sample_list	data;
	i_img_dim	offset;
	i_img_dim	width;
#line 3367 "Imager.xs"
	i_img_dim r;
#line 9587 "Imager.c"
	undef_neg_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        SvGETMAGIC(ST(3));
	if (SvOK(ST(3))) {
	  AV *channels_av;
	  int i;
	  if (!SvROK(ST(3)) || SvTYPE(SvRV(ST(3))) != SVt_PVAV) {
	    croak("channels is not an array ref");
	  }
	  channels_av = (AV *)SvRV(ST(3));
 	  channels.count = av_len(channels_av) + 1;
	  if (channels.count < 1) {
	    croak("Imager::i_psamp: no channels provided");
	  }
	  channels.channels = malloc_temp(aTHX_ sizeof(int) * channels.count);
 	  for (i = 0; i < channels.count; ++i) {
	    SV **entry = av_fetch(channels_av, i, 0);
	    channels.channels[i] = entry ? SvIV(*entry) : 0;
	  }
        }
	else {
	  /* assumes we have an image */
	  channels.count = im->channels;
	  channels.channels = NULL;
	};

	SvGETMAGIC(ST(4));
	if (!SvOK(ST(4)))
	  croak("data must be a scalar or an arrayref");
	if (SvROK(ST(4))) {
	  i_img_dim i;
	  AV *av;
	  i_sample_t *s;
	  if (SvTYPE(SvRV(ST(4))) != SVt_PVAV)
	    croak("data must be a scalar or an arrayref");
	  av = (AV *)SvRV(ST(4));
          data.count = av_len(av) + 1;
          if (data.count < 1)
	    croak("Imager::i_psamp: no samples provided in data");
	  s = malloc_temp(aTHX_ sizeof(i_sample_t) * data.count);
 	  for (i = 0; i < data.count; ++i) {
	    SV **entry = av_fetch(av, i, 0);
 	    s[i] = entry ? SvIV(*entry) : 0;
	  }
          data.samples = s;
	}
	else {
	  /* non-magic would be preferable here */
	  data.samples = (const i_sample_t *)SvPVbyte(ST(4), data.count);
	  if (data.count == 0)
	    croak("Imager::i_psamp: no samples provided in data");
	};

	if (items < 6)
	    offset = 0;
	else {
	    offset = (i_img_dim)SvIV(ST(5));
	}

	if (items < 7)
	    width = -1;
	else {
	    width = (i_img_dim)SvIV(ST(6));
	}
#line 3369 "Imager.xs"
	i_clear_error();
	if (offset < 0) {
	  i_push_error(0, "offset must be non-negative");
	  XSRETURN_UNDEF;
	}
	if (offset > 0) {
	  if (offset > data.count) {
	    i_push_error(0, "offset greater than number of samples supplied");
	    XSRETURN_UNDEF;
	  }
	  data.samples += offset;
	  data.count -= offset;
	}
	if (width == -1 ||
	    width * channels.count > data.count) {
	  width = data.count / channels.count;
        }
	r = x + width;
	RETVAL = i_psamp(im, x, r, y, data.samples, channels.channels, channels.count);
#line 9690 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL < 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_psampf); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_psampf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 5 || items > 7)
       croak_xs_usage(cv,  "im, x, y, channels, data, offset = 0, width = -1");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	i_channel_list	channels;
	i_fsample_list	data;
	i_img_dim	offset;
	i_img_dim	width;
#line 3401 "Imager.xs"
	i_img_dim r;
#line 9719 "Imager.c"
	undef_neg_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        SvGETMAGIC(ST(3));
	if (SvOK(ST(3))) {
	  AV *channels_av;
	  int i;
	  if (!SvROK(ST(3)) || SvTYPE(SvRV(ST(3))) != SVt_PVAV) {
	    croak("channels is not an array ref");
	  }
	  channels_av = (AV *)SvRV(ST(3));
 	  channels.count = av_len(channels_av) + 1;
	  if (channels.count < 1) {
	    croak("Imager::i_psampf: no channels provided");
	  }
	  channels.channels = malloc_temp(aTHX_ sizeof(int) * channels.count);
 	  for (i = 0; i < channels.count; ++i) {
	    SV **entry = av_fetch(channels_av, i, 0);
	    channels.channels[i] = entry ? SvIV(*entry) : 0;
	  }
        }
	else {
	  /* assumes we have an image */
	  channels.count = im->channels;
	  channels.channels = NULL;
	};

	SvGETMAGIC(ST(4));
	if (!SvOK(ST(4)))
	  croak("data must be a scalar or an arrayref");
	if (SvROK(ST(4))) {
	  i_img_dim i;
	  AV *av;
	  i_fsample_t *s;
	  if (SvTYPE(SvRV(ST(4))) != SVt_PVAV)
	    croak("data must be a scalar or an arrayref");
	  av = (AV *)SvRV(ST(4));
          data.count = av_len(av) + 1;
          if (data.count < 1)
	    croak("Imager::i_psampf: no samples provided in data");
	  s = malloc_temp(aTHX_ sizeof(i_fsample_t) * data.count);
 	  for (i = 0; i < data.count; ++i) {
	    SV **entry = av_fetch(av, i, 0);
 	    s[i] = entry ? SvNV(*entry) : 0;
	  }
          data.samples = s;
	}
	else {
	  /* non-magic would be preferable here */
	  data.samples = (const i_fsample_t *)SvPVbyte(ST(4), data.count);
	  if (data.count % sizeof(double))
	    croak("Imager::i_psampf: data doesn't not contain a integer number of samples");
          data.count /= sizeof(double);
	  if (data.count == 0)
	    croak("Imager::i_psampf: no samples provided in data");
	};

	if (items < 6)
	    offset = 0;
	else {
	    offset = (i_img_dim)SvIV(ST(5));
	}

	if (items < 7)
	    width = -1;
	else {
	    width = (i_img_dim)SvIV(ST(6));
	}
#line 3403 "Imager.xs"
	i_clear_error();
	if (offset < 0) {
	  i_push_error(0, "offset must be non-negative");
	  XSRETURN_UNDEF;
	}
	if (offset > 0) {
	  if (offset > data.count) {
	    i_push_error(0, "offset greater than number of samples supplied");
	    XSRETURN_UNDEF;
	  }
	  data.samples += offset;
	  data.count -= offset;
	}
	if (width == -1 ||
	    width * channels.count > data.count) {
	  width = data.count / channels.count;
        }
	r = x + width;
	RETVAL = i_psampf(im, x, r, y, data.samples, channels.channels, channels.count);
#line 9825 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL < 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_masked_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_masked_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "targ, mask, x, y, w, h");
    {
	Imager__ImgRaw	targ;
	i_img_dim	x = (i_img_dim)SvIV(ST(2));
	i_img_dim	y = (i_img_dim)SvIV(ST(3));
	i_img_dim	w = (i_img_dim)SvIV(ST(4));
	i_img_dim	h = (i_img_dim)SvIV(ST(5));
#line 3433 "Imager.xs"
        i_img *mask;
#line 9852 "Imager.c"
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            targ = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                targ = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "targ is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "targ is not of type Imager::ImgRaw");
#line 3435 "Imager.xs"
        if (SvOK(ST(1))) {
          if (!sv_isobject(ST(1)) 
              || !sv_derived_from(ST(1), "Imager::ImgRaw")) {
            croak("i_img_masked_new: parameter 2 must undef or an image");
          }
          mask = INT2PTR(i_img *, SvIV((SV *)SvRV(ST(1))));
        }
        else
          mask = NULL;
        RETVAL = i_img_masked_new(targ, mask, x, y, w, h);
#line 9883 "Imager.c"
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_plin); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_plin)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3)
       croak_xs_usage(cv,  "im, l, y, ...");
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
#line 3454 "Imager.xs"
        i_color *work;
        STRLEN i;
        STRLEN len;
        size_t count;
#line 9911 "Imager.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3459 "Imager.xs"
        if (items > 3) {
          if (items == 4 && SvOK(ST(3)) && !SvROK(ST(3))) {
	    /* supplied as a byte string */
            work = (i_color *)SvPV(ST(3), len);
            count = len / sizeof(i_color);
	    if (count * sizeof(i_color) != len) {
              croak("i_plin: length of scalar argument must be multiple of sizeof i_color");
            }
            RETVAL = i_plin(im, l, l+count, y, work);
          }
	  else {
            work = mymalloc(sizeof(i_color) * (items-3));
            for (i=0; i < items-3; ++i) {
              if (sv_isobject(ST(i+3)) 
                  && sv_derived_from(ST(i+3), "Imager::Color")) {
                IV tmp = SvIV((SV *)SvRV(ST(i+3)));
                work[i] = *INT2PTR(i_color *, tmp);
              }
              else {
                myfree(work);
                croak("i_plin: pixels must be Imager::Color objects");
              }
            }
            RETVAL = i_plin(im, l, l+items-3, y, work);
            myfree(work);
          }
        }
        else {
          RETVAL = 0;
        }
#line 9963 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_ppixf); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_ppixf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, x, y, cl");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
	Imager__Color__Float	cl;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    cl = INT2PTR(Imager__Color__Float,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_ppixf",
			"cl", "Imager::Color::Float");

	RETVAL = i_ppixf(im, x, y, cl);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_gsampf); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_gsampf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, l, r, y, channels");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	r = (i_img_dim)SvIV(ST(2));
	i_img_dim	y = (i_img_dim)SvIV(ST(3));
	i_channel_list	channels;
#line 3507 "Imager.xs"
        i_fsample_t *data;
        i_img_dim count, i;
#line 10043 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

        SvGETMAGIC(ST(4));
	if (SvOK(ST(4))) {
	  AV *channels_av;
	  int i;
	  if (!SvROK(ST(4)) || SvTYPE(SvRV(ST(4))) != SVt_PVAV) {
	    croak("channels is not an array ref");
	  }
	  channels_av = (AV *)SvRV(ST(4));
 	  channels.count = av_len(channels_av) + 1;
	  if (channels.count < 1) {
	    croak("Imager::i_gsampf: no channels provided");
	  }
	  channels.channels = malloc_temp(aTHX_ sizeof(int) * channels.count);
 	  for (i = 0; i < channels.count; ++i) {
	    SV **entry = av_fetch(channels_av, i, 0);
	    channels.channels[i] = entry ? SvIV(*entry) : 0;
	  }
        }
	else {
	  /* assumes we have an image */
	  channels.count = im->channels;
	  channels.channels = NULL;
	};
#line 3510 "Imager.xs"
        if (l < r) {
          data = mymalloc(sizeof(i_fsample_t) * (r-l) * channels.count);
          count = i_gsampf(im, l, r, y, data, channels.channels, channels.count);
          if (GIMME_V == G_ARRAY) {
            EXTEND(SP, count);
            for (i = 0; i < count; ++i)
              PUSHs(sv_2mortal(newSVnv(data[i])));
          }
          else {
            EXTEND(SP, 1);
            PUSHs(sv_2mortal(newSVpv((void *)data, count * sizeof(i_fsample_t))));
          }
          myfree(data);
        }
        else {
          if (GIMME_V != G_ARRAY) {
            EXTEND(SP, 1);
            PUSHs(&PL_sv_undef);
          }
        }
#line 10107 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_plinf); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_plinf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3)
       croak_xs_usage(cv,  "im, l, y, ...");
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
#line 3537 "Imager.xs"
        i_fcolor *work;
        i_img_dim i;
        STRLEN len;
        size_t count;
#line 10133 "Imager.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3542 "Imager.xs"
        if (items > 3) {
          if (items == 4 && SvOK(ST(3)) && !SvROK(ST(3))) {
	    /* supplied as a byte string */
            work = (i_fcolor *)SvPV(ST(3), len);
            count = len / sizeof(i_fcolor);
	    if (count * sizeof(i_fcolor) != len) {
              croak("i_plin: length of scalar argument must be multiple of sizeof i_fcolor");
            }
            RETVAL = i_plinf(im, l, l+count, y, work);
          }
	  else {
            work = mymalloc(sizeof(i_fcolor) * (items-3));
            for (i=0; i < items-3; ++i) {
              if (sv_isobject(ST(i+3)) 
                  && sv_derived_from(ST(i+3), "Imager::Color::Float")) {
                IV tmp = SvIV((SV *)SvRV(ST(i+3)));
                work[i] = *INT2PTR(i_fcolor *, tmp);
              }
              else {
                myfree(work);
                croak("i_plinf: pixels must be Imager::Color::Float objects");
              }
            }
            /**(char *)0 = 1;*/
            RETVAL = i_plinf(im, l, l+items-3, y, work);
            myfree(work);
          }
        }
        else {
          RETVAL = 0;
        }
#line 10186 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_gpixf); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_gpixf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "im, x, y");
    {
	Imager__ImgRaw	im;
	i_img_dim	x = (i_img_dim)SvIV(ST(1));
	i_img_dim	y = (i_img_dim)SvIV(ST(2));
#line 3582 "Imager.xs"
        i_fcolor *color;
#line 10209 "Imager.c"
	SV *	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3584 "Imager.xs"
	color = (i_fcolor *)mymalloc(sizeof(i_fcolor));
	if (i_gpixf(im, x, y, color) == 0) {
          RETVAL = NEWSV(0,0);
          sv_setref_pv(RETVAL, "Imager::Color::Float", (void *)color);
        }
        else {
          myfree(color);
          RETVAL = &PL_sv_undef;
        }
#line 10239 "Imager.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager_i_glin); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_glin)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, l, r, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	r = (i_img_dim)SvIV(ST(2));
	i_img_dim	y = (i_img_dim)SvIV(ST(3));
#line 3603 "Imager.xs"
        i_color *vals;
        i_img_dim count, i;
#line 10267 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3606 "Imager.xs"
        if (l < r) {
          vals = mymalloc((r-l) * sizeof(i_color));
          memset(vals, 0, (r-l) * sizeof(i_color));
          count = i_glin(im, l, r, y, vals);
	  if (GIMME_V == G_ARRAY) {
            EXTEND(SP, count);
            for (i = 0; i < count; ++i) {
              SV *sv = make_i_color_sv(aTHX_ vals+i);
              PUSHs(sv);
            }
          }
          else if (count) {
	    EXTEND(SP, 1);
	    PUSHs(sv_2mortal(newSVpv((void *)vals, count * sizeof(i_color))));
          }
          myfree(vals);
        }
#line 10304 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_glinf); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_glinf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, l, r, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
	i_img_dim	l = (i_img_dim)SvIV(ST(1));
	i_img_dim	r = (i_img_dim)SvIV(ST(2));
	i_img_dim	y = (i_img_dim)SvIV(ST(3));
#line 3631 "Imager.xs"
        i_fcolor *vals;
        i_img_dim count, i;
        i_fcolor zero;
#line 10332 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3635 "Imager.xs"
	for (i = 0; i < MAXCHANNELS; ++i)
	  zero.channel[i] = 0;
        if (l < r) {
          vals = mymalloc((r-l) * sizeof(i_fcolor));
          for (i = 0; i < r-l; ++i)
	    vals[i] = zero;
          count = i_glinf(im, l, r, y, vals);
          if (GIMME_V == G_ARRAY) {
            EXTEND(SP, count);
            for (i = 0; i < count; ++i) {
              SV *sv;
              i_fcolor *col = mymalloc(sizeof(i_fcolor));
              *col = vals[i];
              sv = sv_newmortal();
              sv_setref_pv(sv, "Imager::Color::Float", (void *)col);
              PUSHs(sv);
            }
          }
          else if (count) {
            EXTEND(SP, 1);
            PUSHs(sv_2mortal(newSVpv((void *)vals, count * sizeof(i_fcolor))));
          }
          myfree(vals);
        }
#line 10376 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_img_8_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_8_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "x, y, ch");
    {
	i_img_dim	x = (i_img_dim)SvIV(ST(0));
	i_img_dim	y = (i_img_dim)SvIV(ST(1));
	int	ch = (int)SvIV(ST(2));
	Imager__ImgRaw	RETVAL;

	RETVAL = i_img_8_new(x, y, ch);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_16_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_16_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "x, y, ch");
    {
	i_img_dim	x = (i_img_dim)SvIV(ST(0));
	i_img_dim	y = (i_img_dim)SvIV(ST(1));
	int	ch = (int)SvIV(ST(2));
	Imager__ImgRaw	RETVAL;

	RETVAL = i_img_16_new(x, y, ch);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_to_rgb16); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_to_rgb16)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_img_to_rgb16(im);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_double_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_double_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "x, y, ch");
    {
	i_img_dim	x = (i_img_dim)SvIV(ST(0));
	i_img_dim	y = (i_img_dim)SvIV(ST(1));
	int	ch = (int)SvIV(ST(2));
	Imager__ImgRaw	RETVAL;

	RETVAL = i_img_double_new(x, y, ch);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_img_to_drgb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_img_to_drgb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_img_to_drgb(im);
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Imager_i_tags_addn); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tags_addn)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "im, name, code, idata");
    {
	Imager__ImgRaw	im;
	int	code = (int)SvIV(ST(2));
	int	idata = (int)SvIV(ST(3));
#line 3692 "Imager.xs"
        char *name;
        STRLEN len;
#line 10557 "Imager.c"
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3695 "Imager.xs"
        if (SvOK(ST(1)))
          name = SvPV(ST(1), len);
        else
          name = NULL;
        RETVAL = i_tags_addn(&im->tags, name, code, idata);
#line 10583 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_tags_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tags_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "im, name, code, data, idata");
    {
	Imager__ImgRaw	im;
	int	code = (int)SvIV(ST(2));
	int	idata = (int)SvIV(ST(4));
#line 3709 "Imager.xs"
        char *name;
        char *data;
        STRLEN len;
#line 10610 "Imager.c"
	undef_int	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3713 "Imager.xs"
        if (SvOK(ST(1)))
          name = SvPV(ST(1), len);
        else
          name = NULL;
        if (SvOK(ST(3)))
          data = SvPV(ST(3), len);
        else {
          data = NULL;
          len = 0;
        }
        RETVAL = i_tags_add(&im->tags, name, code, data, len, idata);
#line 10642 "Imager.c"
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_tags_find); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tags_find)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "im, name, start");
    {
	Imager__ImgRaw	im;
	char *	name = (char *)SvPV_nolen(ST(1));
	int	start = (int)SvIV(ST(2));
#line 3733 "Imager.xs"
        int entry;
#line 10667 "Imager.c"
	SV *	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3735 "Imager.xs"
        if (i_tags_find(&im->tags, name, start, &entry)) {
          if (entry == 0)
            RETVAL = newSVpv("0 but true", 0);
          else
            RETVAL = newSViv(entry);
        } else {
          RETVAL = &PL_sv_undef;
        }
#line 10696 "Imager.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager_i_tags_findn); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tags_findn)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "im, code, start");
    {
	Imager__ImgRaw	im;
	int	code = (int)SvIV(ST(1));
	int	start = (int)SvIV(ST(2));
#line 3752 "Imager.xs"
        int entry;
#line 10720 "Imager.c"
	SV *	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3754 "Imager.xs"
        if (i_tags_findn(&im->tags, code, start, &entry)) {
          if (entry == 0)
            RETVAL = newSVpv("0 but true", 0);
          else
            RETVAL = newSViv(entry);
        }
        else {
          RETVAL = &PL_sv_undef;
        }
#line 10750 "Imager.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager_i_tags_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tags_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, entry");
    {
	Imager__ImgRaw	im;
	int	entry = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3771 "Imager.xs"
        RETVAL = i_tags_delete(&im->tags, entry);
#line 10793 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_tags_delbyname); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tags_delbyname)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, name");
    {
	Imager__ImgRaw	im;
	char *	name = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3780 "Imager.xs"
        RETVAL = i_tags_delbyname(&im->tags, name);
#line 10835 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_tags_delbycode); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tags_delbycode)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, code");
    {
	Imager__ImgRaw	im;
	int	code = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3789 "Imager.xs"
        RETVAL = i_tags_delbycode(&im->tags, code);
#line 10877 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_tags_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tags_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, index");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
	int	index = (int)SvIV(ST(1));

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3798 "Imager.xs"
        if (index >= 0 && index < im->tags.count) {
          i_img_tag *entry = im->tags.tags + index;
          EXTEND(SP, 5);

          if (entry->name) {
            PUSHs(sv_2mortal(newSVpv(entry->name, 0)));
          }
          else {
            PUSHs(sv_2mortal(newSViv(entry->code)));
          }
          if (entry->data) {
            PUSHs(sv_2mortal(newSVpvn(entry->data, entry->size)));
          }
          else {
            PUSHs(sv_2mortal(newSViv(entry->idata)));
          }
        }
#line 10935 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_tags_get_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tags_get_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "im, what_sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Imager__ImgRaw	im;
	SV *	what_sv = ST(1);
#line 3821 "Imager.xs"
        char const *name = NULL;
        int code;
        char buffer[200];
#line 10961 "Imager.c"

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3825 "Imager.xs"
        if (SvIOK(what_sv)) {
          code = SvIV(what_sv);
          name = NULL;
        }
        else {
          name = SvPV_nolen(what_sv);
          code = 0;
        }
        if (i_tags_get_string(&im->tags, name, code, buffer, sizeof(buffer))) {
          EXTEND(SP, 1);
          PUSHs(sv_2mortal(newSVpv(buffer, 0)));
        }
#line 10993 "Imager.c"
	PUTBACK;
	return;
    }
}


XS(XS_Imager_i_tags_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_tags_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
#line 3842 "Imager.xs"
        RETVAL = im->tags.count;
#line 11034 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__FillHandle_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__FillHandle_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fill");
    {
	Imager__FillHandle	fill;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    fill = INT2PTR(Imager__FillHandle,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Imager::FillHandle::DESTROY",
			"fill");

	IFILL_DESTROY(fill);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager__FillHandle_CLONE_SKIP); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__FillHandle_CLONE_SKIP)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 3857 "Imager.xs"
        (void)items; /* avoid unused warning for XS variable */
        RETVAL = 1;
#line 11084 "Imager.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_new_fill_solid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_new_fill_solid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "cl, combine");
    {
	Imager__Color	cl;
	int	combine = (int)SvIV(ST(1));
	Imager__FillHandle	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_new_fill_solid",
			"cl", "Imager::Color");

	RETVAL = i_new_fill_solid(cl, combine);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::FillHandle", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_new_fill_solidf); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_new_fill_solidf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "cl, combine");
    {
	Imager__Color__Float	cl;
	int	combine = (int)SvIV(ST(1));
	Imager__FillHandle	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = INT2PTR(Imager__Color__Float,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_new_fill_solidf",
			"cl", "Imager::Color::Float");

	RETVAL = i_new_fill_solidf(cl, combine);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::FillHandle", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_new_fill_hatch); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_new_fill_hatch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "fg, bg, combine, hatch, cust_hatch, dx, dy");
    {
	Imager__Color	fg;
	Imager__Color	bg;
	int	combine = (int)SvIV(ST(2));
	int	hatch = (int)SvIV(ST(3));
	i_img_dim	dx = (i_img_dim)SvIV(ST(5));
	i_img_dim	dy = (i_img_dim)SvIV(ST(6));
#line 3883 "Imager.xs"
        unsigned char *cust_hatch;
        STRLEN len;
#line 11175 "Imager.c"
	Imager__FillHandle	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    fg = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_new_fill_hatch",
			"fg", "Imager::Color");

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    bg = INT2PTR(Imager__Color,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_new_fill_hatch",
			"bg", "Imager::Color");
#line 3886 "Imager.xs"
        if (SvOK(ST(4))) {
          cust_hatch = (unsigned char *)SvPV(ST(4), len);
        }
        else
          cust_hatch = NULL;
        RETVAL = i_new_fill_hatch(fg, bg, combine, hatch, cust_hatch, dx, dy);
#line 11202 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::FillHandle", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_new_fill_hatchf); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_new_fill_hatchf)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "fg, bg, combine, hatch, cust_hatch, dx, dy");
    {
	Imager__Color__Float	fg;
	Imager__Color__Float	bg;
	int	combine = (int)SvIV(ST(2));
	int	hatch = (int)SvIV(ST(3));
	i_img_dim	dx = (i_img_dim)SvIV(ST(5));
	i_img_dim	dy = (i_img_dim)SvIV(ST(6));
#line 3904 "Imager.xs"
        unsigned char *cust_hatch;
        STRLEN len;
#line 11230 "Imager.c"
	Imager__FillHandle	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    fg = INT2PTR(Imager__Color__Float,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_new_fill_hatchf",
			"fg", "Imager::Color::Float");

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Imager::Color::Float")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    bg = INT2PTR(Imager__Color__Float,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::i_new_fill_hatchf",
			"bg", "Imager::Color::Float");
#line 3907 "Imager.xs"
        if (SvOK(ST(4))) {
          cust_hatch = (unsigned char *)SvPV(ST(4), len);
        }
        else
          cust_hatch = NULL;
        RETVAL = i_new_fill_hatchf(fg, bg, combine, hatch, cust_hatch, dx, dy);
#line 11257 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::FillHandle", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager_i_new_fill_image); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager_i_new_fill_image)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "src, matrix, xoff, yoff, combine");
    {
	Imager__ImgRaw	src;
	i_img_dim	xoff = (i_img_dim)SvIV(ST(2));
	i_img_dim	yoff = (i_img_dim)SvIV(ST(3));
	int	combine = (int)SvIV(ST(4));
#line 3923 "Imager.xs"
        double matrix[9];
        double *matrixp;
        AV *av;
        IV len;
        SV *sv1;
        int i;
#line 11287 "Imager.c"
	Imager__FillHandle	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            src = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                src = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "src is not of type Imager::ImgRaw");
#line 3930 "Imager.xs"
        if (!SvOK(ST(1))) {
          matrixp = NULL;
        }
        else {
          if (!SvROK(ST(1)) || SvTYPE(SvRV(ST(1))) != SVt_PVAV)
            croak("i_new_fill_image: parameter must be an arrayref");
	  av=(AV*)SvRV(ST(1));
	  len=av_len(av)+1;
          if (len > 9)
            len = 9;
          for (i = 0; i < len; ++i) {
	    sv1=(*(av_fetch(av,i,0)));
	    matrix[i] = SvNV(sv1);
          }
          for (; i < 9; ++i)
            matrix[i] = 0;
          matrixp = matrix;
        }
        RETVAL = i_new_fill_image(src, matrixp, xoff, yoff, combine);
#line 11327 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::FillHandle", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__Internal__Hlines_testing); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Internal__Hlines_testing)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = i_int_hlines_testing();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if i_int_hlines_testing()
#define XSubPPtmpAAAB 1


XS(XS_Imager__Internal__Hlines_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Internal__Hlines_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "start_y, count_y, start_x, count_x");
    {
	i_img_dim	start_y = (i_img_dim)SvIV(ST(0));
	int	count_y = (int)SvIV(ST(1));
	i_img_dim	start_x = (i_img_dim)SvIV(ST(2));
	int	count_x = (int)SvIV(ST(3));
	Imager__Internal__Hlines	RETVAL;

	RETVAL = i_int_hlines_new(start_y, count_y, start_x, count_x);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Internal::Hlines", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__Internal__Hlines_new_img); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Internal__Hlines_new_img)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "im");
    {
	Imager__ImgRaw	im;
	Imager__Internal__Hlines	RETVAL;

        if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            im = INT2PTR(Imager__ImgRaw,tmp);
        }
        else if (sv_derived_from(ST(0), "Imager") && 
                 SvTYPE(SvRV(ST(0))) == SVt_PVHV) {
            HV *hv = (HV *)SvRV(ST(0));
            SV **sv = hv_fetch(hv, "IMG", 3, 0);
            if (sv && *sv && sv_derived_from(*sv, "Imager::ImgRaw")) {
                IV tmp = SvIV((SV*)SvRV(*sv));
                im = INT2PTR(Imager__ImgRaw,tmp);
            }
            else
                Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");
        }
        else
            Perl_croak(aTHX_ "im is not of type Imager::ImgRaw");

	RETVAL = i_int_hlines_new_img(im);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Internal::Hlines", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Imager__Internal__Hlines_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Internal__Hlines_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "hlines, y, minx, width");
    {
	Imager__Internal__Hlines	hlines;
	i_img_dim	y = (i_img_dim)SvIV(ST(1));
	i_img_dim	minx = (i_img_dim)SvIV(ST(2));
	i_img_dim	width = (i_img_dim)SvIV(ST(3));

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Internal::Hlines")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    hlines = INT2PTR(Imager__Internal__Hlines,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Internal::Hlines::add",
			"hlines", "Imager::Internal::Hlines");

	i_int_hlines_add(hlines, y, minx, width);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager__Internal__Hlines_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Internal__Hlines_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "hlines");
    {
	Imager__Internal__Hlines	hlines;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    hlines = INT2PTR(Imager__Internal__Hlines,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Imager::Internal::Hlines::DESTROY",
			"hlines");

	i_int_hlines_DESTROY(hlines);
    }
    XSRETURN_EMPTY;
}


XS(XS_Imager__Internal__Hlines_dump); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Internal__Hlines_dump)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "hlines");
    {
	Imager__Internal__Hlines	hlines;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Imager::Internal::Hlines")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    hlines = INT2PTR(Imager__Internal__Hlines,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Imager::Internal::Hlines::dump",
			"hlines", "Imager::Internal::Hlines");

	RETVAL = i_int_hlines_dump(hlines);
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Imager__Internal__Hlines_CLONE_SKIP); /* prototype to pass -Wmissing-prototypes */
XS(XS_Imager__Internal__Hlines_CLONE_SKIP)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "cls");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = i_int_hlines_CLONE_SKIP(cls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef __cplusplus
extern "C"
#endif
XS(boot_Imager); /* prototype to pass -Wmissing-prototypes */
XS(boot_Imager)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

        newXS("Imager::Color::new_internal", XS_Imager__Color_new_internal, file);
        newXS("Imager::Color::DESTROY", XS_Imager__Color_DESTROY, file);
        newXS("Imager::Color::set_internal", XS_Imager__Color_set_internal, file);
        newXS("Imager::Color::info", XS_Imager__Color_info, file);
        newXS("Imager::Color::rgba", XS_Imager__Color_rgba, file);
        newXS("Imager::Color::i_hsv_to_rgb", XS_Imager__Color_i_hsv_to_rgb, file);
        newXS("Imager::Color::i_rgb_to_hsv", XS_Imager__Color_i_rgb_to_hsv, file);
        newXS("Imager::Color::Float::new_internal", XS_Imager__Color__Float_new_internal, file);
        newXS("Imager::Color::Float::DESTROY", XS_Imager__Color__Float_DESTROY, file);
        newXS("Imager::Color::Float::rgba", XS_Imager__Color__Float_rgba, file);
        newXS("Imager::Color::Float::set_internal", XS_Imager__Color__Float_set_internal, file);
        newXS("Imager::Color::Float::i_hsv_to_rgb", XS_Imager__Color__Float_i_hsv_to_rgb, file);
        newXS("Imager::Color::Float::i_rgb_to_hsv", XS_Imager__Color__Float_i_rgb_to_hsv, file);
        newXS("Imager::ImgRaw::new", XS_Imager__ImgRaw_new, file);
        newXS("Imager::ImgRaw::DESTROY", XS_Imager__ImgRaw_DESTROY, file);
        (void)newXSproto_portable("Imager::io_new_fd", XS_Imager_io_new_fd, file, "$");
        (void)newXSproto_portable("Imager::io_new_bufchain", XS_Imager_io_new_bufchain, file, "");
        (void)newXSproto_portable("Imager::io_new_buffer", XS_Imager_io_new_buffer, file, "$");
        (void)newXSproto_portable("Imager::io_new_cb", XS_Imager_io_new_cb, file, "$$$$;$");
        (void)newXSproto_portable("Imager::io_slurp", XS_Imager_io_slurp, file, "$");
        (void)newXSproto_portable("Imager::i_set_image_file_limits", XS_Imager_i_set_image_file_limits, file, "$$$");
        (void)newXSproto_portable("Imager::i_get_image_file_limits", XS_Imager_i_get_image_file_limits, file, "");
        newXS("Imager::i_int_check_image_file_limits", XS_Imager_i_int_check_image_file_limits, file);
        (void)newXSproto_portable("Imager::IO::new_fd", XS_Imager__IO_new_fd, file, "$$");
        (void)newXSproto_portable("Imager::IO::new_buffer", XS_Imager__IO_new_buffer, file, "$$");
        (void)newXSproto_portable("Imager::IO::new_cb", XS_Imager__IO_new_cb, file, "$$$$$");
        (void)newXSproto_portable("Imager::IO::new_bufchain", XS_Imager__IO_new_bufchain, file, "$");
        (void)newXSproto_portable("Imager::IO::slurp", XS_Imager__IO_slurp, file, "$$");
        (void)newXSproto_portable("Imager::IO::raw_write", XS_Imager__IO_raw_write, file, "$$");
        (void)newXSproto_portable("Imager::IO::raw_read", XS_Imager__IO_raw_read, file, "$$$");
        (void)newXSproto_portable("Imager::IO::raw_read2", XS_Imager__IO_raw_read2, file, "$$");
        (void)newXSproto_portable("Imager::IO::raw_seek", XS_Imager__IO_raw_seek, file, "$$$");
        (void)newXSproto_portable("Imager::IO::raw_close", XS_Imager__IO_raw_close, file, "$");
        (void)newXSproto_portable("Imager::IO::DESTROY", XS_Imager__IO_DESTROY, file, "$");
        (void)newXSproto_portable("Imager::IO::CLONE_SKIP", XS_Imager__IO_CLONE_SKIP, file, ";@");
        (void)newXSproto_portable("Imager::IO::getc", XS_Imager__IO_getc, file, "$");
        (void)newXSproto_portable("Imager::IO::putc", XS_Imager__IO_putc, file, "$$");
        (void)newXSproto_portable("Imager::IO::close", XS_Imager__IO_close, file, "$");
        (void)newXSproto_portable("Imager::IO::flush", XS_Imager__IO_flush, file, "$");
        (void)newXSproto_portable("Imager::IO::peekc", XS_Imager__IO_peekc, file, "$");
        (void)newXSproto_portable("Imager::IO::seek", XS_Imager__IO_seek, file, "$$$");
        (void)newXSproto_portable("Imager::IO::peekn", XS_Imager__IO_peekn, file, "$$");
        (void)newXSproto_portable("Imager::IO::read", XS_Imager__IO_read, file, "$$$");
        (void)newXSproto_portable("Imager::IO::read2", XS_Imager__IO_read2, file, "$$");
        (void)newXSproto_portable("Imager::IO::gets", XS_Imager__IO_gets, file, "$;$$");
        (void)newXSproto_portable("Imager::IO::write", XS_Imager__IO_write, file, "$$");
        (void)newXSproto_portable("Imager::IO::dump", XS_Imager__IO_dump, file, "$;$");
        (void)newXSproto_portable("Imager::IO::set_buffered", XS_Imager__IO_set_buffered, file, "$;$");
        (void)newXSproto_portable("Imager::IO::is_buffered", XS_Imager__IO_is_buffered, file, "$");
        (void)newXSproto_portable("Imager::IO::eof", XS_Imager__IO_eof, file, "$");
        (void)newXSproto_portable("Imager::IO::error", XS_Imager__IO_error, file, "$");
        (void)newXSproto_portable("Imager::i_list_formats", XS_Imager_i_list_formats, file, "");
        (void)newXSproto_portable("Imager::i_sametype", XS_Imager_i_sametype, file, "$$$");
        (void)newXSproto_portable("Imager::i_sametype_chans", XS_Imager_i_sametype_chans, file, "$$$$");
        (void)newXSproto_portable("Imager::i_init_log", XS_Imager_i_init_log, file, "$$");
        (void)newXSproto_portable("Imager::i_log_entry", XS_Imager_i_log_entry, file, "$$");
        (void)newXSproto_portable("Imager::i_log_enabled", XS_Imager_i_log_enabled, file, "");
        (void)newXSproto_portable("Imager::i_img_info", XS_Imager_i_img_info, file, "$");
        (void)newXSproto_portable("Imager::i_img_setmask", XS_Imager_i_img_setmask, file, "$$");
        (void)newXSproto_portable("Imager::i_img_getmask", XS_Imager_i_img_getmask, file, "$");
        (void)newXSproto_portable("Imager::i_img_getchannels", XS_Imager_i_img_getchannels, file, "$");
        (void)newXSproto_portable("Imager::i_img_getdata", XS_Imager_i_img_getdata, file, "$");
        (void)newXSproto_portable("Imager::i_img_get_width", XS_Imager_i_img_get_width, file, "$");
        (void)newXSproto_portable("Imager::i_img_get_height", XS_Imager_i_img_get_height, file, "$");
        (void)newXSproto_portable("Imager::i_img_is_monochrome", XS_Imager_i_img_is_monochrome, file, "$");
        (void)newXSproto_portable("Imager::i_line", XS_Imager_i_line, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_line_aa", XS_Imager_i_line_aa, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_box", XS_Imager_i_box, file, "$$$$$$");
        (void)newXSproto_portable("Imager::i_box_filled", XS_Imager_i_box_filled, file, "$$$$$$");
        (void)newXSproto_portable("Imager::i_box_filledf", XS_Imager_i_box_filledf, file, "$$$$$$");
        (void)newXSproto_portable("Imager::i_box_cfill", XS_Imager_i_box_cfill, file, "$$$$$$");
        (void)newXSproto_portable("Imager::i_arc", XS_Imager_i_arc, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_arc_aa", XS_Imager_i_arc_aa, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_arc_cfill", XS_Imager_i_arc_cfill, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_arc_aa_cfill", XS_Imager_i_arc_aa_cfill, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_circle_aa", XS_Imager_i_circle_aa, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_circle_out", XS_Imager_i_circle_out, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_circle_out_aa", XS_Imager_i_circle_out_aa, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_arc_out", XS_Imager_i_arc_out, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_arc_out_aa", XS_Imager_i_arc_out_aa, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_bezier_multi", XS_Imager_i_bezier_multi, file, "$$$$");
        (void)newXSproto_portable("Imager::i_poly_aa", XS_Imager_i_poly_aa, file, "$$$$");
        (void)newXSproto_portable("Imager::i_poly_aa_cfill", XS_Imager_i_poly_aa_cfill, file, "$$$$");
        (void)newXSproto_portable("Imager::i_flood_fill", XS_Imager_i_flood_fill, file, "$$$$");
        (void)newXSproto_portable("Imager::i_flood_cfill", XS_Imager_i_flood_cfill, file, "$$$$");
        (void)newXSproto_portable("Imager::i_flood_fill_border", XS_Imager_i_flood_fill_border, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_flood_cfill_border", XS_Imager_i_flood_cfill_border, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_copyto", XS_Imager_i_copyto, file, "$$$$$$$$");
        (void)newXSproto_portable("Imager::i_copyto_trans", XS_Imager_i_copyto_trans, file, "$$$$$$$$$");
        (void)newXSproto_portable("Imager::i_copy", XS_Imager_i_copy, file, "$");
        (void)newXSproto_portable("Imager::i_rubthru", XS_Imager_i_rubthru, file, "$$$$$$$$");
        (void)newXSproto_portable("Imager::i_compose", XS_Imager_i_compose, file, "$$$$$$$$;$$");
        (void)newXSproto_portable("Imager::i_compose_mask", XS_Imager_i_compose_mask, file, "$$$$$$$$$$$;$$");
        (void)newXSproto_portable("Imager::i_combine", XS_Imager_i_combine, file, "$;$");
        (void)newXSproto_portable("Imager::i_flipxy", XS_Imager_i_flipxy, file, "$$");
        (void)newXSproto_portable("Imager::i_rotate90", XS_Imager_i_rotate90, file, "$$");
        (void)newXSproto_portable("Imager::i_rotate_exact", XS_Imager_i_rotate_exact, file, "$$;@");
        (void)newXSproto_portable("Imager::i_matrix_transform", XS_Imager_i_matrix_transform, file, "$$$$;@");
        (void)newXSproto_portable("Imager::i_gaussian", XS_Imager_i_gaussian, file, "$$");
        (void)newXSproto_portable("Imager::i_unsharp_mask", XS_Imager_i_unsharp_mask, file, "$$$");
        (void)newXSproto_portable("Imager::i_conv", XS_Imager_i_conv, file, "$$");
        (void)newXSproto_portable("Imager::i_convert", XS_Imager_i_convert, file, "$$");
        (void)newXSproto_portable("Imager::i_map", XS_Imager_i_map, file, "$$");
        (void)newXSproto_portable("Imager::i_img_diff", XS_Imager_i_img_diff, file, "$$");
        (void)newXSproto_portable("Imager::i_img_diffd", XS_Imager_i_img_diffd, file, "$$");
        (void)newXSproto_portable("Imager::i_img_samef", XS_Imager_i_img_samef, file, "$$;$$");
        (void)newXSproto_portable("Imager::i_img_epsilonf", XS_Imager_i_img_epsilonf, file, "");
        (void)newXSproto_portable("Imager::_is_color_object", XS_Imager__is_color_object, file, "$");
#if XSubPPtmpAAAA
        (void)newXSproto_portable("Imager::i_tt_new", XS_Imager_i_tt_new, file, "$");
        (void)newXSproto_portable("Imager::Font::TT::DESTROY", XS_Imager__Font__TT_DESTROY, file, "$");
        (void)newXSproto_portable("Imager::Font::TT::CLONE_SKIP", XS_Imager__Font__TT_CLONE_SKIP, file, ";@");
        (void)newXSproto_portable("Imager::i_tt_text", XS_Imager_i_tt_text, file, "$$$$$$$$$$;$");
        (void)newXSproto_portable("Imager::i_tt_cp", XS_Imager_i_tt_cp, file, "$$$$$$$$$$;$");
        (void)newXSproto_portable("Imager::i_tt_bbox", XS_Imager_i_tt_bbox, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_tt_has_chars", XS_Imager_i_tt_has_chars, file, "$$$");
        (void)newXSproto_portable("Imager::i_tt_dump_names", XS_Imager_i_tt_dump_names, file, "$");
        (void)newXSproto_portable("Imager::i_tt_face_name", XS_Imager_i_tt_face_name, file, "$");
        (void)newXSproto_portable("Imager::i_tt_glyph_name", XS_Imager_i_tt_glyph_name, file, "$$;$");
#endif
        (void)newXSproto_portable("Imager::i_test_format_probe", XS_Imager_i_test_format_probe, file, "$$");
        (void)newXSproto_portable("Imager::i_readpnm_wiol", XS_Imager_i_readpnm_wiol, file, "$$");
        (void)newXSproto_portable("Imager::i_readpnm_multi_wiol", XS_Imager_i_readpnm_multi_wiol, file, "$$");
        (void)newXSproto_portable("Imager::i_writeppm_wiol", XS_Imager_i_writeppm_wiol, file, "$$");
        (void)newXSproto_portable("Imager::i_readraw_wiol", XS_Imager_i_readraw_wiol, file, "$$$$$$");
        (void)newXSproto_portable("Imager::i_writeraw_wiol", XS_Imager_i_writeraw_wiol, file, "$$");
        (void)newXSproto_portable("Imager::i_writebmp_wiol", XS_Imager_i_writebmp_wiol, file, "$$");
        (void)newXSproto_portable("Imager::i_readbmp_wiol", XS_Imager_i_readbmp_wiol, file, "$;$");
        (void)newXSproto_portable("Imager::i_writetga_wiol", XS_Imager_i_writetga_wiol, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_readtga_wiol", XS_Imager_i_readtga_wiol, file, "$$");
        (void)newXSproto_portable("Imager::i_scaleaxis", XS_Imager_i_scaleaxis, file, "$$$");
        (void)newXSproto_portable("Imager::i_scale_nn", XS_Imager_i_scale_nn, file, "$$$");
        (void)newXSproto_portable("Imager::i_scale_mixing", XS_Imager_i_scale_mixing, file, "$$$");
        (void)newXSproto_portable("Imager::i_haar", XS_Imager_i_haar, file, "$");
        (void)newXSproto_portable("Imager::i_count_colors", XS_Imager_i_count_colors, file, "$$");
        (void)newXSproto_portable("Imager::i_get_anonymous_color_histo", XS_Imager_i_get_anonymous_color_histo, file, "$;$");
        (void)newXSproto_portable("Imager::i_transform", XS_Imager_i_transform, file, "$$$$");
        (void)newXSproto_portable("Imager::i_transform2", XS_Imager_i_transform2, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_contrast", XS_Imager_i_contrast, file, "$$");
        (void)newXSproto_portable("Imager::i_hardinvert", XS_Imager_i_hardinvert, file, "$");
        (void)newXSproto_portable("Imager::i_hardinvertall", XS_Imager_i_hardinvertall, file, "$");
        (void)newXSproto_portable("Imager::i_noise", XS_Imager_i_noise, file, "$$$");
        (void)newXSproto_portable("Imager::i_bumpmap", XS_Imager_i_bumpmap, file, "$$$$$$");
        (void)newXSproto_portable("Imager::i_bumpmap_complex", XS_Imager_i_bumpmap_complex, file, "$$$$$$$$$$$$$$");
        (void)newXSproto_portable("Imager::i_postlevels", XS_Imager_i_postlevels, file, "$$");
        (void)newXSproto_portable("Imager::i_mosaic", XS_Imager_i_mosaic, file, "$$");
        (void)newXSproto_portable("Imager::i_watermark", XS_Imager_i_watermark, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_autolevels", XS_Imager_i_autolevels, file, "$$$$");
        (void)newXSproto_portable("Imager::i_radnoise", XS_Imager_i_radnoise, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_turbnoise", XS_Imager_i_turbnoise, file, "$$$$");
        (void)newXSproto_portable("Imager::i_gradgen", XS_Imager_i_gradgen, file, "$;@");
        (void)newXSproto_portable("Imager::i_diff_image", XS_Imager_i_diff_image, file, "$$;$");
        (void)newXSproto_portable("Imager::i_fountain", XS_Imager_i_fountain, file, "$$$$$$$$$$$");
        (void)newXSproto_portable("Imager::i_new_fill_fount", XS_Imager_i_new_fill_fount, file, "$$$$$$$$$$");
        (void)newXSproto_portable("Imager::i_new_fill_opacity", XS_Imager_i_new_fill_opacity, file, "$$");
        (void)newXSproto_portable("Imager::i_errors", XS_Imager_i_errors, file, "");
        (void)newXSproto_portable("Imager::i_clear_error", XS_Imager_i_clear_error, file, "");
        (void)newXSproto_portable("Imager::i_push_error", XS_Imager_i_push_error, file, "$$");
        (void)newXSproto_portable("Imager::i_nearest_color", XS_Imager_i_nearest_color, file, "$;@");
        (void)newXSproto_portable("Imager::malloc_state", XS_Imager_malloc_state, file, "");
        (void)newXSproto_portable("Imager::DSO_open", XS_Imager_DSO_open, file, "$");
        (void)newXSproto_portable("Imager::DSO_close", XS_Imager_DSO_close, file, "$");
        (void)newXSproto_portable("Imager::DSO_funclist", XS_Imager_DSO_funclist, file, "$");
        (void)newXSproto_portable("Imager::DSO_call", XS_Imager_DSO_call, file, "$$$");
        (void)newXSproto_portable("Imager::i_get_pixel", XS_Imager_i_get_pixel, file, "$$$");
        (void)newXSproto_portable("Imager::i_ppix", XS_Imager_i_ppix, file, "$$$$");
        (void)newXSproto_portable("Imager::i_img_pal_new", XS_Imager_i_img_pal_new, file, "$$$$");
        (void)newXSproto_portable("Imager::i_img_to_pal", XS_Imager_i_img_to_pal, file, "$$");
        (void)newXSproto_portable("Imager::i_img_to_rgb", XS_Imager_i_img_to_rgb, file, "$");
        (void)newXSproto_portable("Imager::i_img_make_palette", XS_Imager_i_img_make_palette, file, "$;@");
        (void)newXSproto_portable("Imager::i_gpal", XS_Imager_i_gpal, file, "$$$$");
        (void)newXSproto_portable("Imager::i_ppal", XS_Imager_i_ppal, file, "$$$;@");
        (void)newXSproto_portable("Imager::i_ppal_p", XS_Imager_i_ppal_p, file, "$$$$");
        (void)newXSproto_portable("Imager::i_addcolors", XS_Imager_i_addcolors, file, "$;@");
        (void)newXSproto_portable("Imager::i_setcolors", XS_Imager_i_setcolors, file, "$$;@");
        (void)newXSproto_portable("Imager::i_getcolors", XS_Imager_i_getcolors, file, "$$;@");
        (void)newXSproto_portable("Imager::i_colorcount", XS_Imager_i_colorcount, file, "$");
        (void)newXSproto_portable("Imager::i_maxcolors", XS_Imager_i_maxcolors, file, "$");
        (void)newXSproto_portable("Imager::i_findcolor", XS_Imager_i_findcolor, file, "$$");
        (void)newXSproto_portable("Imager::i_img_bits", XS_Imager_i_img_bits, file, "$");
        (void)newXSproto_portable("Imager::i_img_type", XS_Imager_i_img_type, file, "$");
        (void)newXSproto_portable("Imager::i_img_virtual", XS_Imager_i_img_virtual, file, "$");
        (void)newXSproto_portable("Imager::i_gsamp", XS_Imager_i_gsamp, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_gsamp_bits", XS_Imager_i_gsamp_bits, file, "$$$$$$$$");
        (void)newXSproto_portable("Imager::i_psamp_bits", XS_Imager_i_psamp_bits, file, "$$$$$$;$$");
        (void)newXSproto_portable("Imager::i_psamp", XS_Imager_i_psamp, file, "$$$$$;$$");
        (void)newXSproto_portable("Imager::i_psampf", XS_Imager_i_psampf, file, "$$$$$;$$");
        (void)newXSproto_portable("Imager::i_img_masked_new", XS_Imager_i_img_masked_new, file, "$$$$$$");
        (void)newXSproto_portable("Imager::i_plin", XS_Imager_i_plin, file, "$$$;@");
        (void)newXSproto_portable("Imager::i_ppixf", XS_Imager_i_ppixf, file, "$$$$");
        (void)newXSproto_portable("Imager::i_gsampf", XS_Imager_i_gsampf, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_plinf", XS_Imager_i_plinf, file, "$$$;@");
        (void)newXSproto_portable("Imager::i_gpixf", XS_Imager_i_gpixf, file, "$$$");
        (void)newXSproto_portable("Imager::i_glin", XS_Imager_i_glin, file, "$$$$");
        (void)newXSproto_portable("Imager::i_glinf", XS_Imager_i_glinf, file, "$$$$");
        (void)newXSproto_portable("Imager::i_img_8_new", XS_Imager_i_img_8_new, file, "$$$");
        (void)newXSproto_portable("Imager::i_img_16_new", XS_Imager_i_img_16_new, file, "$$$");
        (void)newXSproto_portable("Imager::i_img_to_rgb16", XS_Imager_i_img_to_rgb16, file, "$");
        (void)newXSproto_portable("Imager::i_img_double_new", XS_Imager_i_img_double_new, file, "$$$");
        (void)newXSproto_portable("Imager::i_img_to_drgb", XS_Imager_i_img_to_drgb, file, "$");
        (void)newXSproto_portable("Imager::i_tags_addn", XS_Imager_i_tags_addn, file, "$$$$");
        (void)newXSproto_portable("Imager::i_tags_add", XS_Imager_i_tags_add, file, "$$$$$");
        (void)newXSproto_portable("Imager::i_tags_find", XS_Imager_i_tags_find, file, "$$$");
        (void)newXSproto_portable("Imager::i_tags_findn", XS_Imager_i_tags_findn, file, "$$$");
        (void)newXSproto_portable("Imager::i_tags_delete", XS_Imager_i_tags_delete, file, "$$");
        (void)newXSproto_portable("Imager::i_tags_delbyname", XS_Imager_i_tags_delbyname, file, "$$");
        (void)newXSproto_portable("Imager::i_tags_delbycode", XS_Imager_i_tags_delbycode, file, "$$");
        (void)newXSproto_portable("Imager::i_tags_get", XS_Imager_i_tags_get, file, "$$");
        (void)newXSproto_portable("Imager::i_tags_get_string", XS_Imager_i_tags_get_string, file, "$$");
        (void)newXSproto_portable("Imager::i_tags_count", XS_Imager_i_tags_count, file, "$");
        (void)newXSproto_portable("Imager::FillHandle::DESTROY", XS_Imager__FillHandle_DESTROY, file, "$");
        (void)newXSproto_portable("Imager::FillHandle::CLONE_SKIP", XS_Imager__FillHandle_CLONE_SKIP, file, ";@");
        (void)newXSproto_portable("Imager::i_new_fill_solid", XS_Imager_i_new_fill_solid, file, "$$");
        (void)newXSproto_portable("Imager::i_new_fill_solidf", XS_Imager_i_new_fill_solidf, file, "$$");
        (void)newXSproto_portable("Imager::i_new_fill_hatch", XS_Imager_i_new_fill_hatch, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_new_fill_hatchf", XS_Imager_i_new_fill_hatchf, file, "$$$$$$$");
        (void)newXSproto_portable("Imager::i_new_fill_image", XS_Imager_i_new_fill_image, file, "$$$$$");
        (void)newXSproto_portable("Imager::Internal::Hlines::testing", XS_Imager__Internal__Hlines_testing, file, "");
#if XSubPPtmpAAAB
        (void)newXSproto_portable("Imager::Internal::Hlines::new", XS_Imager__Internal__Hlines_new, file, "$$$$");
        (void)newXSproto_portable("Imager::Internal::Hlines::new_img", XS_Imager__Internal__Hlines_new_img, file, "$");
        (void)newXSproto_portable("Imager::Internal::Hlines::add", XS_Imager__Internal__Hlines_add, file, "$$$$");
        (void)newXSproto_portable("Imager::Internal::Hlines::DESTROY", XS_Imager__Internal__Hlines_DESTROY, file, "$");
        (void)newXSproto_portable("Imager::Internal::Hlines::dump", XS_Imager__Internal__Hlines_dump, file, "$");
        (void)newXSproto_portable("Imager::Internal::Hlines::CLONE_SKIP", XS_Imager__Internal__Hlines_CLONE_SKIP, file, "$");
#endif

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#line 3993 "Imager.xs"
        PERL_SET_GLOBAL_CALLBACKS;
	PERL_PL_SET_GLOBAL_CALLBACKS;

#line 11796 "Imager.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

